/****************************************************************************
   Posledni upravy ze dne 12.9.1998 provedl:
                          Martin Lexa (e-mail: mlexa@students.zcu.cz)

   Licence - Public Domain


   banner.c v0.75beta - zdrojovy soubor
*****************************************************************************/
#include <stdio.h>


#define VEL_FONT 8                                     // Delka a sirka znaku

unsigned char font_tab[VEL_FONT * VEL_FONT * 256];     // Tabulka s fonty


void cti_font(char *soubor, int pocet)
{
   FILE *fr;


   if ((fr = fopen(soubor, "rb")) == NULL) {
     clrscr();
     printf("Nemuzu otevrit soubor: %s!\n", soubor);
     exit(1);
   }

   fread(font_tab, 1, VEL_FONT * VEL_FONT * pocet, fr);
   fclose(fr);
}

void zobraz_text(int x, int y, char *text, int barva)
{
   int i, j, index, pocet;


   textattr(barva);
   pocet = strlen(text);                        // Vyhleda dany znak v font tabulce
   for (index = 0; index <= pocet; index++) {
       for (i = 0; i < VEL_FONT; i++) {
           for (j = 0; j < VEL_FONT; j++) {
               if (font_tab[((int) text[index] * VEL_FONT * VEL_FONT) +
                  ((i * VEL_FONT) + j)] == 100) {
                  gotoxy(x + index * VEL_FONT + j, y + i + 1);  // A vykresli
                  cprintf("*\n");
               } else {
                 gotoxy(x + index * VEL_FONT + j, y + i + 1);
                 cprintf(" \n");
               }
           }
       }
  }
  textattr(7);
}

void zobraz_banner(int x, int y, int pmeze_x1, int pmeze_x2, char *text,
                   int barva, int prodleva, int kolikrat)
{
   int i, j, k, l, yy, pocet;
   int index, meze_x1, meze_x2;
   char buffer[VEL_FONT * VEL_FONT * 256];


   k = 0;
   yy = y;
   pocet = strlen(text);
   meze_x2 = pmeze_x2;
   meze_x1 = pmeze_x1;

   textattr(barva);

   for (index = 0; index < pocet; index++) {    // Text -> Font_tab -> Buffer
           for (i = 0; i < VEL_FONT; i++) {     // Znaky musi jit za sebou
               for (j = 0; j < VEL_FONT; j++) {
                   if (font_tab[((int) text[index] * VEL_FONT * VEL_FONT) +
                      ((i * VEL_FONT) + j)] == 100)
                      buffer[i * pocet * VEL_FONT + index * VEL_FONT + j] = '*';
                   else
                      buffer[i * pocet * VEL_FONT + index * VEL_FONT + j] = ' ';
               }
           }
   }

//       Buffer -> Zobrazeni (s prodlevou + barva) * kolikrat

   for (l = 0; l < kolikrat * (pocet * VEL_FONT - pmeze_x2 - pmeze_x1); l++) {
       if (meze_x2 >= pocet * VEL_FONT) {
          meze_x2 = pmeze_x2;
          meze_x1 = pmeze_x1;
       }
       for (j = 0; j < VEL_FONT; j++) {
           for (i = meze_x1; i < meze_x2; i++) {
               gotoxy(x + k, yy);
               k++;
               cprintf("%c\n", buffer[i + j * pocet * VEL_FONT]);
           }
           yy++;
           k = 0;
       }
       meze_x2++;
       meze_x1++;
       yy = y;
       delay(prodleva);
   }
   textattr(7);
}