uses dos, crt, m_files;

const
  max_nodes = 255;

type
  t_count_rec = record
    value: byte;   { hodnota }
    count: word;   { jeji cetnost }
  end;

  t_count_tab_ptr = ^t_count_tab;
  t_count_tab = array[0..max_nodes] of word;

  t_node_ptr = ^t_node;
  t_node = record
    value: byte;
    id: byte;
    p: t_node_ptr;
    b: array[0..1] of t_node_ptr;
  end;

  t_node_arr = array[0..max_nodes] of t_node;
  t_node_array2 = ^t_node_arr;

  t_node_ptrarr = array[0..max_nodes] of t_node_ptr;

  t_tree_ptr =^t_tree;
  t_tree = object
    root: t_node_ptr;
    node: t_node_array2;
    count: word;

    constructor init(var _base: t_count_tab; _count: word);
    destructor done; virtual;
    procedure build_tree; virtual;
    procedure get_code(idx: word; var _nbits: byte; var _code: word); virtual;
  end;

  t_code_tab_rec = record
    nbits: byte;
    code: word;
  end;

  t_code_table = array[0..255] of t_code_tab_rec;

  t_code_tab2_rec = record
    value: byte;
    nbits: byte;
    code: word;
  end;

  t_code_table2 = array[0..255] of t_code_tab2_rec;


  t_dest = object
    f: tfile;

    constructor init(var _f: tfile);
    destructor done; virtual;
    procedure writebyte(_b: byte); virtual;
  end;

  t_bit_buffer = object(t_dest)
    buffer: byte;
    bit_idx: byte;

    constructor init;
    destructor done; virtual;
    procedure set_bit(_bit: byte); virtual;
  end;


var
  i: integer;

  c_tab: t_count_tab;

  root_node: t_node_ptr;

  cnt: word;
  n_nodes: word;

  code_tab: t_code_table;
  code_tab2: t_code_table2;

  source_file, dest_file: tfile;

  bit_buffer: t_bit_buffer;

constructor t_tree.init(var _base: t_count_tab; _count: word);
var
  i, j: word;
begin
  count:=_count;
  getmem(node, count * sizeof(t_node));
  { zaalokovat pole nodu }

  i:=0;
  j:=0;

{  for i:=0 to count-1 do
  begin
}
  while j<256 do
  begin
    if _base[j]<>0 then
    begin
      node^[i].value:=_base[j];
      node^[i].id:=j;
      node^[i].p:=nil;
      node^[i].b[0]:=nil;
      node^[i].b[1]:=nil;
      inc(i);
    end;
    inc(j);
  end;
{  end;
}
  root:=nil;
end;

destructor t_tree.done;
begin
  freemem(node, count * sizeof(t_node));
  node:=nil;
end;

procedure find_min(var inp_pole: t_node_ptrarr; mis,kon: word; var idx1: word);
var
  i: word;
  min,idx: word;
begin
  min:=$ffff;
  idx:=0;

  for i:=0 to kon-1 do
  begin
    if (i<>mis) and (inp_pole[i]^.value<min) then
    begin
      idx:=i;
      min:=inp_pole[i]^.value;
    end;
  end;
  idx1:=idx;
end;

procedure t_tree.build_tree;
var
  c, i, h: word;
  inp_pole, out_pole: t_node_ptrarr; { pole pointru na nody }

  lo_limit, idx1, idx2: word;

  temp_node: t_node_ptr;
begin
  for i:=0 to count-1 do
  begin
    inp_pole[i]:=addr(node^[i]);
  end;

  c:=count;
  while (c>1) do
  begin
    find_min(inp_pole, $ffff, c, idx1);
    find_min(inp_pole, idx1, c, idx2);

    if idx1>idx2 then
    begin
      h:=idx1;
      idx1:=idx2;
      idx2:=h;
    end;

    new(temp_node);

    temp_node^.value:=inp_pole[idx1]^.value + inp_pole[idx2]^.value;
    temp_node^.p:=nil;
    temp_node^.b[0]:=inp_pole[idx1];
    temp_node^.b[1]:=inp_pole[idx2];

    inp_pole[idx1]^.p:=temp_node;
    inp_pole[idx2]^.p:=temp_node;

    inp_pole[idx1]:=temp_node;

    for i:=idx2+1 to c-1 do
      inp_pole[i-1]:=inp_pole[i];
    dec(c);
  end;
  root:=temp_node;
end;

procedure t_tree.get_code(idx: word; var _nbits: byte; var _code: word);
var
  i: word;

  a_node, temp_node: t_node_ptr;
  steps: byte;
  code: word;
begin
  a_node:=addr(node^[idx]);

  code:=0;
  steps:=0;

  while (a_node^.p<>nil) do
  begin
    temp_node:=a_node^.p;
    inc(steps);
    if temp_node^.b[1]=a_node then
      code:=code or (1 shl (steps-1));

    a_node:=temp_node;
  end;
  _nbits:=steps;
  _code:=code;
end;

procedure make_code_table(tree: t_tree_ptr; var ctab: t_code_table);
var
  nbits: byte;
  code: word;
  id: word;
begin
  for i:=0 to tree^.count-1 do
  begin
    tree^.get_code(i, nbits, code);

    ctab[tree^.node^[i].id].nbits:=nbits;
    ctab[tree^.node^[i].id].code:=code;
  end;
end;


constructor t_dest.init(var _f: tfile);
begin
  f:=_f;
end;

destructor t_dest.done;
begin
end;

procedure t_dest.writebyte(_b: byte);
var
  error: word;
  result: word;
begin
  error:=write_block(f, _b, sizeof(_b), result);
end;

constructor t_bit_buffer.init;
begin
  bit_idx:=8;
end;

destructor t_bit_buffer.done;
begin
end;

procedure t_bit_buffer.set_bit(_bit: byte);
begin
  if bit_idx=0 then
  begin
    writebyte(buffer);
    buffer:=0;
    bit_idx:=8;
  end;
  dec(bit_idx);
  buffer:=buffer or (_bit shl bit_idx);
end;

procedure init;
var
  error: word;
begin
  error:=open_file(source_file, paramstr(1), readonly);
  check_error(error);

  error:=make_file(dest_file, paramstr(2));
  check_error(error);
end;

procedure deinit;
var
  error: word;
begin
  if source_file.open then
  begin
    error:=close_file(source_file);
    check_error(error);
  end;
end;

procedure make_stat;
var
  buffer: array[0..2*1024-1] of byte;
  error, result: word;
  i: word;
begin
  seek_file(source_file, 0);

  repeat
    error:=read_block(source_file, buffer, sizeof(buffer), result);
    check_error(error);

    for i:=0 to result-1 do
      inc(c_tab[buffer[i]]);
  until (result<sizeof(buffer));

  n_nodes:=0;
  for i:=0 to 255 do
    if c_tab[i]<>0 then inc(n_nodes);
  seek_file(source_file, 0);
end;


procedure encode(source: tfile);
var
  buffer: array[0..2*1024-1] of byte;
  error: word;
  result: word;
  i, j: word;

  ctab_idx: word;

  pom_pos: longint;
  l: longint;
begin
  j:=0;
  for i:=0 to 255 do
  begin
    if code_tab[i].nbits<>0 then
    begin
      code_tab2[j].value:=i;
      code_tab2[j].nbits:=code_tab[i].nbits;
      code_tab2[j].code:=code_tab[i].code;
      inc(j);
    end;
  end;
  error:=write_block(bit_buffer.f, j, sizeof(j), result);
  error:=write_block(bit_buffer.f, code_tab2, j * sizeof(t_code_tab2_rec), result);
  check_error(error);

  l:=0;
  pom_pos:=filepos(bit_buffer.f.f);
  error:=write_block(bit_buffer.f, l, sizeof(l), result);

  while not(eof(source.f)) do
  begin
    error:=read_block(source, buffer, sizeof(buffer), result);
    check_error(error);

    for i:=0 to result-1 do
    begin
      ctab_idx:=buffer[i];

      for j:=code_tab[ctab_idx].nbits-1 downto 0 do
      begin
        bit_buffer.set_bit(code_tab[ctab_idx].code and (1 shl j) shr j);
        inc(l);
      end;
    end;

  end;

  if bit_buffer.bit_idx<>8 then bit_buffer.writebyte(bit_buffer.buffer);

  seek(bit_buffer.f.f, pom_pos);
  error:=write_block(bit_buffer.f, l, sizeof(l), result);
end;


procedure write_help;
begin
  writeln;
  writeln('Huffmann codec 1.00   by David Andrs');
  writeln;
  writeln('Usage:');
  writeln('   huffenc [input file] [output file]');
  writeln;
  writeln('   [input file] - name of file to encode');
  writeln('   [output file] - name of output file');
  writeln;
end;

var
  tree: ^t_tree;

begin
  if paramcount<2 then
  begin
    write_help;
  end else
      begin
        init;

        writeln('making stats...');
        make_stat;

        bit_buffer.init;

        bit_buffer.f:=dest_file;

        writeln('making tree...');
        new(tree, init(c_tab, n_nodes));
        tree^.build_tree;
        make_code_table(tree, code_tab);

        writeln('encoding...');
        encode(source_file);

        dispose(tree, done);

        bit_buffer.done;

        deinit;
      end;
end.