{ modul pro praci se soubory }

{ verze 2.00  18.10.1998        David Andrs }
unit m_files;
{$I-}

interface

uses dos;

const
  readonly  = 0;
  writeonly = 1;
  readwrite = 2;

type
  tfile = record
    f: file;
    name: string;
    handle: word;
    open: boolean;
  end;

  tDTA = record
    disc: byte;                                             { a=1, b=2, ... }
    name: array[0..7] of char;         { jmeno souboru vcetne ?. upper-case }
    ext: array[0..3] of char;                             { pripona souboru }
    attr: byte;                                          { atributy souboru }
    dirindexno: word;             { cislo polozky adresare v tomto clusteru }
    clusterno: word;              { cislo clusteru adresare nebo 0 pro root }
    dummy: array[0..3] of byte;                              { zde byvaji 0 }

    fileatr: byte;                            { atributy nalezeneho souboru }
    filetime: word;                      { cas vytvoreni/modifikace souboru }
    filedate: word;                    { datum vytvoreni/modifikace souboru }
    filesize: longint;                          { velikost souboru v bytech }
    filename: array[0..13] of char;                  { ASCIIZ jmeno souboru }
  end;
  { DOSem definovana struktura }

  function get_disk: byte;
  { zjisti vybrany disk DOSu}
  procedure set_disk(d: byte);
  { nastavi vybrany disk DOSu}
  function make_dir(name: string): word;
  { vytvori adresar se jmenem name }
  function del_dir(name: string): word;
  { vymaze adresar se jmenem name }
  { adresar musi byt prazdny }
  function change_dir(name: string): word;
  { nastavi aktivni adresar }
  function get_dir(disc: byte; var dir: string): word;
  { zjisti aktivni adresar na disku disc }
  { do dir vrati ASCIIZ }
  function make_file(var f: tfile; name: string): word;
  { vytvori soubor se jmenem name }
  function rewrite_file(var f: tfile): word;
  { vytvori soubor se jmenem f.name. Pokud soubor existuje, prepise ho }
  function open_file(var f: tfile; name: string; mode: byte): word;
  { otevre soubor name v pristupovem rezimu mode }
  function close_file(var f: tfile): word;
  { zavre soubor f }
  function read_block(var f: tfile; var data; size: word; var res: word): word;
  { nacte size bytu ze souboru f do promenne data }
  { do res vrati skutecny pocet prectenych bytu pri uspesnem ukonceni operace }
  function write_block(var f: tfile; var data; size: word; var res: word): word;
  { zapise size bytu do souboru f z promenne data }
  { do res vrati skutecny pocet zapsanych bytu pri uspesnem ukonceni operace }
  function delete_file(var f: tfile): word;
  { vymaze soubor f }
  function rename_file(var f: tfile; newname: string): word;
  { prejmenuje soubor f na newname }

  function find_firstfile(filename: string; attr: byte; var DTA: searchrec): word;
  { najde prvni soubor danych parametru }
  function find_nextfile(var DTA: searchrec): word;
  { najde dalsi soubor specifikovanych pozadavku }
  function seek_file(var f: tfile; filepos: longint): word;
  { posune ukazatel v souboru na filepos }
  function fsize(var f: tfile): longint;
  { vrati velikost souboru }
  function fpos(var f: tfile): longint;
  { vrati aktualni pozici v souboru }
  function eofile(f: tfile): boolean;
  { vrati TRUE je-li konec souboru, jinak FALSE }


  function disk_free(disc: byte): longint;
  { vrati volne misto na disku }
  function disk_size(disc: byte): longint;
  { vrati celkove misto na disku }

  procedure check_error(error: word);
  { zkontroluje jestli nastala chyba }

implementation

var
  dta: tDTA;

function get_disk: byte;
{ zjisti vybrany disk DOSu}
begin

end;

procedure set_disk(d: byte);
{ nastavi vybrany disk DOSu}
begin
end;

function make_dir(name: string): word;
{ vytvori adresar se jmenem name }
begin
  mkdir(name);
  make_dir:=ioresult;
end;

function del_dir(name: string): word;
{ vymaze adresar se jmenem name }
{ adresar musi byt prazdny }
begin
  rmdir(name);
  del_dir:=ioresult;
end;

function change_dir(name: string): word;
{ nastavi aktivni adresar }
begin
  chdir(name);
  change_dir:=ioresult;
end;

function get_dir(disc: byte; var dir: string): word;
{ zjisti aktivni adresar na disku disc }
{ do dir vrati ASCIIZ }
begin
  getdir(disc,dir);
  get_dir:=0;
end;

function make_file(var f: tfile; name: string): word;
{ vytvori soubor se jmenem name }
begin
  assign(f.f, name);
  f.name:=name;
  rewrite(f.f,1);
  make_file:=ioresult;
end;

function rewrite_file(var f: tfile): word;
{ vytvori soubor se jmenem f.name. Pokud soubor existuje, prepise ho }
begin
  assign(f.f, f.name);
  rewrite(f.f,1);
  rewrite_file:=ioresult;
end;

function open_file(var f: tfile; name: string; mode: byte): word;
{ otevre soubor name v pristupovem rezimu mode }
begin
  assign(f.f,name);
  f.name:=name;
  filemode:=mode;
  reset(f.f,1);
  open_file:=ioresult;
end;

function close_file(var f: tfile): word;
{ zavre soubor f }
begin
  close(f.f);
  close_file:=ioresult;
end;

function read_block(var f: tfile; var data; size: word; var res: word): word;
{ nacte size bytu ze souboru f do promenne data }
{ do res vrati skutecny pocet prectenych bytu pri uspesnem ukonceni operace }
begin
  blockread(f.f,data,size,res);
  read_block:=ioresult;
end;

function write_block(var f: tfile; var data; size: word; var res: word): word;
{ zapise size bytu do souboru f z promenne data }
{ do res vrati skutecny pocet zapsanych bytu pri uspesnem ukonceni operace }
begin
  blockwrite(f.f,data,size,res);
  write_block:=ioresult;
end;

function delete_file(var f: tfile): word;
{ vymaze soubor f }
begin
  erase(f.f);
  delete_file:=ioresult;
end;

function rename_file(var f: tfile; newname: string): word;
{ prejmenuje soubor f na newname }
begin
  rename(f.f, newname);
  rename_file:=ioresult;
end;

function find_firstfile(filename: string; attr: byte; var DTA: searchrec): word;
{ najde prvni soubor danych parametru }
begin
  findfirst(filename,attr,dta);
  find_firstfile:=doserror;
end;

function find_nextfile(var DTA: searchrec): word;
{ najde dalsi soubor specifikovanych pozadavku }
begin
  findnext(dta);
  find_nextfile:=doserror;
end;

function seek_file(var f: tfile; filepos: longint): word;
{ posune ukazatel v souboru na filepos }
begin
  seek(f.f, filepos);
end;

function fsize(var f: tfile): longint;
{ vrati velikost souboru }
begin
  fsize:=filesize(f.f);
end;

function fpos(var f: tfile): longint;
{ vrati aktualni pozici v souboru }
begin
  fpos:=filepos(f.f);
end;

function eofile(f: tfile): boolean;
{ vrati TRUE je-li konec souboru, jinak FALSE }
begin
  eofile:=eof(f.f);
end;


function disk_free(disc: byte): longint;
{ vrati volne misto na disku }
begin
  disk_free:=diskfree(disc);
end;

function disk_size(disc: byte): longint;
{ vrati celkove misto na disku }
begin
  disk_size:=disksize(disc);
end;

procedure check_error(error: word);
begin
  if error<>0 then
  begin
    writeln('Chyba DOSu cislo ', error);
    halt(1);
  end;
end;

begin
end.