unit menu;

interface
  uses crt;
  type t_polozka = string[30]; {polozka menu}
  const {definice menu (=nabidek)}
    menu001: array[0..3] of t_polozka =
      ('3',' oboji',' jen plochu',' jen mravence'); {ulozeni do souboru}
    menu002: array[0..4] of t_polozka =
      ('4',' fletna',' housle',' mravenec',' mam hlad jako vrah'); {pro test}
  procedure dej_menu(menu: array of t_polozka; var odpoved:byte);
    {zobrazi 'menu' a zjisti, kolikatou polozku si uzivatel vybral.
     pokud byla akce zrusena klavesou <ESC>, je vraceno 'odpoved'=0.}
  procedure pis_polozku(jakou:byte; polozka:t_polozka; pozadi, textik:byte);
    {na radek 'jakou' 50 znaku odleva napise 'polozka'. barvy textu
     a pozadi urcuje 'pozadi' a 'textik'.}
implementation
  const cerna = 0; {konstanty pro barvy}
        modra = 1;
        bila  = 15;
        dno   = 20; {na jakem radku bude zacinat menu}
  procedure pis_polozku;
    begin
      gotoxy(51,jakou); {kde se zacne psat}
      textcolor(textik);
      textbackground(pozadi);
      write(polozka); {co se napise}
      clreol; {aby to hezky vypadalo}
    end;
  procedure dej_menu;
    var i,
        delka: byte; {pocet polozek v menu}
        code: integer; {jen pro proceduru 'val'}
        znak: char; {cteni znaku z klavesnice}
        presun: boolean; {TRUE pri stisknuti sipky nahoru a doleva
                          pri pohybu v nabidce}
    begin
      presun:= false;
      val(menu[0],delka,code); {zjisteni delky menu}
      pis_polozku(dno+1,menu[1],modra,bila); {kurzor na prvni polozku}
      for i:= 2 to delka do pis_polozku(dno+i,menu[i],cerna,bila);
        {zobrazeni celeho menu}
      znak:= #65;
      odpoved:= 1; {zaciname s kurzorem na prvni polozce}
      while (ord(znak)<>27) and (ord(znak)<>13) and (ord(znak)<>32) do
        {menu se ukonci stiskem <ESC>, <ENTER> nebo <SPACE>}
      if keypressed then
      begin
        znak:= readkey; {co ze to bylo stisknuto? znak}
        pis_polozku(dno+odpoved,menu[odpoved],cerna,bila);
          {aktualni polozka uz urcite nebude aktualni}
        if ord(znak)=0 then
        begin
          znak:= readkey;
          if (ord(znak)=72) or (ord(znak)=75) then {<LEFT> nebo <UP>}
          begin
            dec(odpoved); {skaceme o jednu polozku vys}
            if odpoved = 0 then odpoved:= delka; {zefektivneni pohybu v menu}
            pis_polozku(dno+odpoved,menu[odpoved],modra,bila);
              {presun kurzoru}
            presun:= true; {pohybovali jsme se nahoru}
          end;
          znak:=#65; {spravna funkcnost algoritmu}
        end;
        if not presun then {kdyz ne <LEFT> nebo <UP>, tak se posuneme nize}
        begin
          inc(odpoved); {skaceme o jednu polozku niz}
          if odpoved > delka then odpoved:=1; {lepsi pohyb v menu}
          pis_polozku(dno+odpoved,menu[odpoved],modra,bila); {presun kurzoru}
        end;
      presun:=1=0; {uz neni potreba kurzor posunovat, uz se stalo}
      end;
      dec(odpoved); {vyruseni posunu kurzoru klavesami <ENTER> nebo <SPACE>}
      if odpoved = 0 then odpoved:= delka; {pro spravnost posunu}
      if znak=#27 then odpoved:= 0; {nevybrano nic}
      for i:= 1 to delka do pis_polozku(dno+i,menu[0],cerna,cerna);
        {smazani menu z monitoru}
    end;
end.