{ modul pro praci s mravenci }
unit m_ants;

interface

uses
  m_antsc, m_area;

type
  t_ant_ptr = ^t_ant;
  t_ant = record
    x, y: integer;
    direction: byte;
    walktime: integer;
    speed: integer;
    is_load: boolean;
    next: t_ant_ptr;
  end;

var
  ant_idx: word;
  act_ant: t_ant_ptr;

function create_ants(_ant_count: word; var ants: t_ant_ptr;
  way: t_create_way; ant_req: t_ant_req_ptr; ant_filename: string): boolean;
procedure deinit_ants(var ants: t_ant_ptr);

procedure control_ant(var area: t_area; _ant: t_ant_ptr);
procedure set_ants_to_area(ants: t_ant_ptr; var area: t_area);
procedure correct_speed(var speed: integer);

procedure add_ant(var ants: t_ant_ptr; _x, _y: integer; _dirc: byte;
  _speed: integer; _load: boolean);
{ prida mravence do spoj. seznamu(cyklickeho) }


implementation

uses
   m_glob, m_dsktp, m_soubor;

const
  walktime_range = 10; { rozsah hodnot 'walktime' }
  walktime_mid   = 8;  { stredni hodnota 'walktime' }
  max_speed      = 5;  { maximalni rychlost }

procedure add_ant(var ants: t_ant_ptr; _x, _y: integer; _dirc: byte;
  _speed: integer; _load: boolean);
{ prida mravence do spoj. seznamu(cyklickeho) }
var
  temp_ptr, dummy_ptr: t_ant_ptr;
  new_ant: t_ant_ptr;
begin
  new(new_ant);
  new_ant^.x:=_x;
  new_ant^.y:=_y;
  new_ant^.direction:=_dirc;
  new_ant^.walktime:=0;
  new_ant^.speed:=_speed;
  new_ant^.is_load:=_load;

  if ants=nil then
  begin
    new_ant^.next:=new_ant;
    ants:=new_ant;
  end else
      begin
        dummy_ptr:=ants^.next;
        ants^.next:=new_ant;
        new_ant^.next:=dummy_ptr;
      end;
end;

procedure add_custom_ants(var ants: t_ant_ptr; ant_req: t_ant_req_ptr);
var
  temp_req: t_ant_req_ptr;
begin
  temp_req:=ant_req;

  while (temp_req<>nil) do
  begin
    add_ant(ants, temp_req^.x, temp_req^.y, temp_req^.direction, 0, FALSE);

    temp_req:=temp_req^.next;
  end;
end;

procedure add_rand_ants(_ant_count: word; var ants: t_ant_ptr);
var
  i: integer;
  d: byte; { nahodny smer }
  x, y: byte;
begin
  for i:=1 to _ant_count do
  begin
    d:=random(8)+1;
    { prekontevruj do vnitrni implementace smeru }
    case d of
      1: d:=9;
      2: d:=1;
      3: d:=3;
      4: d:=2;
      5: d:=6;
      6: d:=4;
      7: d:=12;
    end;
    x:=random(area_width)+1; y:=random(area_height)+1;
    add_ant(ants, x, y, d, 0, FALSE);
  end;
end;

function generate_walktime: integer; forward;
procedure inspect_nextmove(var area: t_area; ant: t_ant_ptr); forward;

procedure create_chaos({var area: t_area; }ants: t_ant_ptr);
{ urci mravencum 'walktime' a 'speed' }
var
  temp_ant: t_ant_ptr;
  i: integer;
begin
  temp_ant:=ants;
  for i:=1 to ant_count do
  begin
    temp_ant^.walktime:=generate_walktime;

    { nastav 'speed' }
{    inspect_nextmove(area, temp_ant);}

    temp_ant:=temp_ant^.next;
  end;
end;

procedure set_ants_to_area(ants: t_ant_ptr; var area: t_area);
var
  i: word;
  temp_ant: t_ant_ptr;
begin
  temp_ant:=ants;
  for i:=1 to ant_count do
  begin
    set_area(area, temp_ant^.x, temp_ant^.y, ANT);

    temp_ant:=temp_ant^.next;
  end;
end;

function create_ants(_ant_count: word; var ants: t_ant_ptr;
  way: t_create_way; ant_req: t_ant_req_ptr; ant_filename: string): boolean;
{ vytvori '_ant_count' mravencu }
begin
{  ant_count:=_ant_count;}
  ant_idx:=0;
  case way of
    READ_FILE:
    begin
     create_ants:=nacti_mravence(ants, ant_filename);
    end;
    RAND:
    begin
      add_rand_ants(_ant_count, ants); create_chaos(ants);
      create_ants:=TRUE;
    end;
    CUSTOM:
    begin
      add_custom_ants(ants, ant_req);  create_chaos(ants);
      create_ants:=TRUE;
    end;
  end;

  act_ant:=ants;
end;

procedure deinit_ants(var ants: t_ant_ptr);
{ zrusi kruh. spoj. seznam 'ants' }
var
  temp_ptr, dummy_ptr: t_ant_ptr;
begin
  if ants<>nil then
  begin
    temp_ptr:=ants^.next;
    ants^.next:=nil;
    while temp_ptr<>nil do
    begin
      dummy_ptr:=temp_ptr^.next;
      dispose(temp_ptr);
      temp_ptr:=dummy_ptr;
    end;
    ants:=nil;
  end;
end;

function generate_walktime: integer;
begin
  generate_walktime:=walktime_mid +
    (random(walktime_range)-(walktime_range div 2));
end;

procedure try_move(dirc: byte; var x, y: integer);
begin
  if dirc and 1=1 then y:=y-1;
  if dirc and 2=2 then x:=x+1;
  if dirc and 4=4 then y:=y+1;
  if dirc and 8=8 then x:=x-1;
end;

function change_direction(ant: t_ant_ptr; var area: t_area): byte;
var
  new_dirc: byte;
  nx, ny: integer;
  try_no: byte;
begin
  new_dirc:=random(8)+1;
  { prekontevruj do vnitrni implementace smeru }
  case new_dirc of
    1: new_dirc:=9;
    2: new_dirc:=1;
    3: new_dirc:=3;
    4: new_dirc:=2;
    5: new_dirc:=6;
    6: new_dirc:=4;
    7: new_dirc:=12;
  end;
  nx:=ant^.x; ny:=ant^.y;
  try_move(new_dirc, nx, ny);

  if (get_area(area, nx, ny)=NOTHING) then
    change_direction:=new_dirc
  else
    change_direction:=0;
end;

procedure correct_speed(var speed: integer);
begin
  if speed<0 then speed:=0
  else
    if speed>max_speed then speed:=max_speed;
end;

procedure inspect_nextmove(var area: t_area; ant: t_ant_ptr);
var
  nx, ny: integer;
  acell, ncell: t_area_cell;
begin
  if ant^.direction<>0 then
  begin
    nx:=ant^.x; ny:=ant^.y;
    acell:=area[nx, ny] and 31;
    try_move(ant^.direction, nx, ny);
    ncell:=area[nx, ny] and 31;

    ant^.speed:=(ncell-acell)+3; { prip. necim prenasobit }
    correct_speed(ant^.speed);
{    if ant^.speed<0 then ant^.speed:=0;
    if ant^.speed>5 then ant^.speed:=5;}
    { prictu 2, protoze potrebuju kladne cislo }
    { -1 klesani, 0 po rovine, 1 do kopce }
  end;
end;

procedure drop_wood(var area: t_area; ant: t_ant_ptr);
begin
  set_area(area, ant^.x, ant^.y, WOOD);
  ant^.is_load:=FALSE;
  dec(wood_carry);
  refresh_wood_carry;
end;

procedure pickup_wood(var area: t_area; x, y: integer; ant: t_ant_ptr);
begin
  set_area(area, x, y, DES_WOOD);
  ant^.is_load:=TRUE;
  inc(wood_carry);
  refresh_wood_carry;
end;


procedure control_ant(var area: t_area; _ant: t_ant_ptr);
var
  new_x, new_y: integer;
  cell: t_area_cell;
begin
  if _ant^.direction=0 then
  begin
    _ant^.direction:=change_direction(_ant, area);
    inspect_nextmove(area, _ant);
  end
  else
  if _ant^.speed=0 then
  begin
{    if _ant^.walktime=0 then
    begin
      _ant^.direction:=change_direction(_ant^.direction);
      _ant^.walktime:=generate_walktime;
    end;}
    new_x:=_ant^.x; new_y:=_ant^.y;
    try_move(_ant^.direction, new_x, new_y);
    cell:=get_area(area, new_x, new_y);
    case cell of
      NOTHING:
      begin
        set_area(area, _ant^.x, _ant^.y, DES_ANT);
{        if graph_on then}
          draw_cell(area, _ant^.x, _ant^.y);
        _ant^.x:=new_x;
        _ant^.y:=new_y;
        set_area(area, _ant^.x, _ant^.y, ANT);
{        if graph_on then}
          draw_cell(area, _ant^.x, _ant^.y);
      end;

      WALL, ANT:
      begin
        _ant^.direction:=change_direction(_ant, area);
{        _ant^.walktime:=generate_walktime;}
      end;

      WOOD:
      begin
        if _ant^.is_load then
          drop_wood(area, _ant)
        else begin
               pickup_wood(area, new_x, new_y, _ant);
{               if graph_on then}
                 draw_cell(area, new_x, new_y);
             end;

{        if graph_on then}
          draw_cell(area, _ant^.x, _ant^.y);
        _ant^.direction:=change_direction(_ant, area);
{        _ant^.walktime:=generate_walktime;}
      end;
    end; { case }

    inspect_nextmove(area, _ant);
{    _ant^.walktime:=_ant^.walktime - 1;}
  end; { if }
end; { control ant }


begin
end.