{ modul pro praci s plochou }
unit m_area;

interface

const
  area_width  = 50;
  area_height = 50;

  NOTHING  = 1;
  WALL     = 2;
  ANT      = 3;
  WOOD     = 4;
  DES_ANT  = 5;
  DES_WOOD = 6;


type
  t_create_way = (READ_FILE, RAND, CUSTOM, FLAT);

  t_area_cell = byte;
  t_area = array[0..area_width+1, 0..area_height+1] of t_area_cell;

function create_area(var area: t_area; way: t_create_way; wood_cnt: word;
  area_filename: string): boolean;
function get_area(var area: t_area; x, y: integer): t_area_cell;
procedure set_area(var area: t_area; x, y: integer; what: t_area_cell);
procedure draw_area(var area: t_area);

procedure draw_cell(var area: t_area; _x, _y: word);

implementation

uses
  crt, m_glob, m_soubor;

procedure rozhod_klaciky(var area: t_area; kolik: word);
var
  i: word;
  x, y: word;
begin
  for i:=1 to kolik do
  begin
    x:=random(area_width)+1;
    y:=random(area_height)+1;
    set_area(area, x, y, WOOD);
  end;

{  wood_count:=kolik;}
end;

procedure create_rand_area(var area: t_area);
const
  max_hills = 7;

  hill : array [0..10, 0..10] of byte = (
   (0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0),
   (0, 0, 1, 1, 2, 2, 2, 1, 1, 0, 0),
   (0, 1, 2, 2, 3, 3, 3, 2, 2, 1, 0),
   (0, 1, 2, 3, 4, 4, 4, 3, 2, 1, 0),
   (1, 2, 3, 4, 5, 5, 5, 4, 3, 2, 1),
   (1, 2, 3, 4, 5, 6, 5, 4, 3, 2, 1),
   (1, 2, 3, 4, 5, 5, 5, 4, 3, 2, 1),
   (0, 1, 2, 3, 4, 4, 4, 3, 2, 1, 0),
   (0, 1, 2, 2, 3, 3, 3, 2, 2, 1, 0),
   (0, 0, 1, 1, 2, 2, 2, 1, 1, 0, 0),
   (0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0));

var
  x, y, z: byte;  { pozice a vyska kopce }
  count: byte;    { pocet kopcu }
  i, j, k: byte;
begin
  { vygeneruj rovinu }
  for i:=1 to area_height do
    for j:=1 to area_width do
      area[j, i]:=0;

  count:=random(10)+50;
{  count:=1;}
  for i:=1 to count do
  begin
    x:=random(area_width)+1;
    y:=random(area_height)+1;
    z:=random(5)+1;

    j:=6-z;
    while j<z+5 do
    begin
      k:=6-z;
      while k<z+5 do
      begin
        if ((x+k-5) in [1..area_width]) and ((y+j-5) in [1..area_height]) then
        begin
          if hill[k, j]-(5-z)>area[x+k-5, y+j-5] then
            area[x+k-5, y+j-5]:=hill[k, j]-(6-z);
        end;

        inc(k);
      end;
      inc(j);
    end;
  end;
end;

function create_area(var area: t_area; way: t_create_way; wood_cnt: word;
  area_filename: string): boolean;
var
  i, j: integer;
begin
  case way of
    READ_FILE:
    begin
      { nacti ze souboru }
      create_area:=nacti_plochu(area, area_filename);
{      if area[1,1]=32 then
        create_rand_area(area);{aby tam byla korektni data}
    end;

    RAND:
    begin
      { generuj oblast }
      create_rand_area(area);

      rozhod_klaciky(area, wood_cnt);
      create_area:=TRUE;
    end;

    CUSTOM:
    begin
    end;

    FLAT:
    begin
      { vygeneruj rovinu }
      for i:=1 to area_height do
        for j:=1 to area_width do
          area[j, i]:=0;

      rozhod_klaciky(area, wood_cnt);
      create_area:=TRUE;
    end;

  end; { case }

  { ohranic plochu }
  for i:=0 to area_width+1 do
  begin
    area[i, 0]:=64;
    area[i, area_height+1]:=64;
  end;

  for i:=1 to area_height do
  begin
    area[0, i]:=64;
    area[area_width+1, i]:=64;
  end;
end;

function get_area(var area: t_area; x, y: integer): t_area_cell;
var
  cell: t_area_cell;
begin
  cell:=area[x, y];
  if cell and 128=128 then
    get_area:=WOOD
  else if cell and 64=64 then
         get_area:=WALL
       else if cell and 32=32 then
              get_area:=ANT
            else get_area:=NOTHING;
end;

procedure set_area(var area: t_area; x, y: integer; what: t_area_cell);
begin
  case what of
    WOOD:     area[x, y]:=area[x, y] or 128;
    NOTHING:  area[x, y]:=area[x, y] and 31;
    ANT:      area[x, y]:=area[x, y] or 32;
    DES_ANT:  area[x, y]:=area[x, y] and ($FF xor 32);
    DES_WOOD: area[x, y]:=area[x, y] and ($FF xor 128);
  end;
end;

procedure draw_area(var area: t_area);
var
  i, j: integer;
  cell: t_area_cell;
  vis: char;          { to, co se objevi na popredi }
begin
  for i:=1 to area_height do
    for j:=1 to area_width do
      draw_cell(area, j, i);
end;

procedure draw_cell(var area: t_area; _x, _y: word);
var
  offset: word;
  ch, color, fore: byte;
begin
  offset:=((_y-1)*160)+((_x-1)*2);
  if area[_x, _y] and 32=32 then
  begin
    ch:=ord('*');
    fore:=00;
  end else
      if area[_x, _y] and 128=128 then
      begin
        ch:=ord('/');
        fore:=9;
      end else
          begin
            ch:=32;  { mezera }
            fore:=00;
          end;

  color:=(((area[_x, _y] and 31)+1) shl 4) or fore;

  mem[$B800:offset]:=ch;
  mem[$B800:offset+1]:=color;
end;


begin
end.