unit m_menu;

interface

uses crt;

type
  t_polozka = string[30]; {polozka menu}

const { definice menu (=nabidek) }
  menu_hlavni: array[0..3] of t_polozka =
    ('3', ' Start simulace', ' Vytvorit...', ' Konec programu');
  menu_vytvorit: array[0..3] of t_polozka =
    ('3', ' Plochu...', ' Mravence...', ' Zpet');
  menu_plochu: array[0..5] of t_polozka =
    ('5', ' Nahodne', ' Ze souboru', ' Bez nerovnosti', ' Pocet vetvicek ',
     ' Zpet');
  menu_mravence: array[0..4] of t_polozka =
    ('4', ' Nahodne', ' Ze souboru', ' Pocet mravencu ', ' Zpet');

  menu_simulace: array[0..5] of t_polozka =
    ('5',' Zpet do simulace',
         ' Zmena rychlosti       <S>',
	 ' Maximalni vykon       <M>',
         ' Ulozit...',
         ' Konec simulace        <Q>');

  menu_ulozit: array[0..4] of t_polozka =
    ('4',' Oboji', ' Jen plochu', ' Jen mravence', ' Zpet');

  menu_noyes: array[0..2] of t_polozka =
    ('2', ' Ne', ' Ano');

procedure dej_menu(menu: array of t_polozka; var odpoved: byte);
{ zobrazi 'menu' a zjisti, kolikatou polozku si uzivatel vybral. }
{ pokud byla akce zrusena klavesou <ESC>, je vraceno 'odpoved'=0.}

procedure pis_polozku(jakou: byte; polozka: t_polozka; pozadi, textik: byte);
{ na radek 'jakou' 50 znaku odleva napise 'polozka'. barvy textu }
{ a pozadi urcuje 'pozadi' a 'textik'. }

function ask(dotaz: string): word;
{ zobrazi 'dotaz' a pole pro zadani ciselne hodnoty z klavesnice.}
{ pokud dojde ke zruseni akce, je vracena nula.}

function titulek(dotaz:string): t_polozka;
{ zobrazi 'dotaz' a pole pro zadani retezce delky nejvyse 30 z klavesnice.}
{ pokud dojde ke zruseni akce, je vracen prazdny retezec.}

procedure say_error(msg: string);
{ zobrazi chybova hlaseni a ceka na stisk klavesy }
{ mj. vyprazdni buffer klavesnice }

implementation

uses
  m_tvga, m_tools;

const
  cerna = 0; {konstanty pro barvy}
  modra = 12;
  bila  = 15;

  dno   = 30; {na jakem radku bude zacinat menu}

  ask_x = 74; {vzdalenost zadavaciho pole zleva}
  ask_y = 31; {radek, kde bude ask pracovat}

  titulek_y = 35; {radek, kde bude titulek pracovat}

procedure say_error(msg: string);
const
  x = 52;
  y = 31;
var
  ch: char;
begin
  write_text(x, y, bila, cerna, msg);
  while keypressed do ch:=readkey;
  readkey;
  write_text(x, y, bila, cerna, replicate(' ', length(msg)));
end;

procedure pis_polozku;
begin
(*  gotoxy(51,jakou); {kde se zacne psat}
	textcolor(textik);
	textbackground(pozadi);
	write(polozka); {co se napise}
	clreol; {aby to hezky vypadalo}
*)
  write_text(52, jakou, textik, pozadi, polozka+replicate(' ', 28-length(polozka)-1));

end;

procedure dej_menu;
var
  i,
  delka: byte;     { pocet polozek v menu }
  code: integer;   { jen pro proceduru 'val' }
  znak: char;      { cteni znaku z klavesnice }
  presun: boolean; { TRUE pri stisknuti sipky nahoru a doleva }
									 { pri pohybu v nabidce }
begin
  presun:=FALSE;
  val(menu[0], delka, code); {zjisteni delky menu}
  pis_polozku(dno+1, menu[1], modra, bila); {kurzor na prvni polozku}
  for i:=2 to delka do
    pis_polozku(dno+i, menu[i], cerna, bila);
    {zobrazeni celeho menu}
  znak:=#65;
  odpoved:=1; {zaciname s kurzorem na prvni polozce}
  while (ord(znak)<>27) and (ord(znak)<>13) and (ord(znak)<>32) do
  {menu se ukonci stiskem <ESC>, <ENTER> nebo <SPACE>}
  if keypressed then
  begin
    znak:=readkey; {co ze to bylo stisknuto? znak}
    pis_polozku(dno+odpoved, menu[odpoved], cerna, bila);
    {aktualni polozka uz urcite nebude aktualni}
    if ord(znak)=0 then
    begin
      znak:= readkey;
      if (ord(znak)=72) or (ord(znak)=75) then {<LEFT> nebo <UP>}
      begin
	dec(odpoved); {skaceme o jednu polozku vys}
	if odpoved = 0 then odpoved:= delka; {zefektivneni pohybu v menu}
	pis_polozku(dno+odpoved,menu[odpoved],modra,bila);
		{presun kurzoru}
	presun:=TRUE; {pohybovali jsme se nahoru}
      end;
      znak:=#65; {spravna funkcnost algoritmu}
     end;
     if not presun then {kdyz ne <LEFT> nebo <UP>, tak se posuneme nize}
     begin
       inc(odpoved); {skaceme o jednu polozku niz}
       if odpoved > delka then odpoved:=1; {lepsi pohyb v menu}
       pis_polozku(dno+odpoved, menu[odpoved], modra, bila); {presun kurzoru}
     end;
     presun:=1=0; {uz neni potreba kurzor posunovat, uz se stalo}
  end;
  dec(odpoved); {vyruseni posunu kurzoru klavesami <ENTER> nebo <SPACE>}
  if odpoved = 0 then odpoved:=delka; {pro spravnost posunu}
  if znak=#27 then odpoved:=0; {nevybrano nic}
  for i:=1 to delka do pis_polozku(dno+i,menu[0],cerna,cerna);
  {smazani menu z monitoru}
end;

function ask(dotaz:string): word;
var
  hotovo, {muzeme pokracovat dal}
  vstup: boolean; {jedna se o dotaz na cislo, nebo je to jen vykrik?}
  znak: char;
  cislo: word;
begin
  cursor_on;
  znak:=#65;
  cislo:=0;
  if dotaz[1]<>'?' then
  begin
    vstup:=1=0;
    gotoxy(52+length(dotaz), ask_y);
  end else
      {zacina-li 'dotaz' otaznikem, bude se pozadovat zadani cisla}
      begin
        vstup:=1=1;
        delete(dotaz, 1, 1); {pryc s tim otaznikem}
        gotoxy(ask_x, ask_y);
      end;
  delete(dotaz, 22, 226); {muze byt zobrazeno jen prvnich 21 znaku}
  pis_polozku(ask_y, dotaz, cerna, bila); {vypsani dotazu}
  while ((znak<>#13) and (znak<>#27) and (znak<>#32)) do
    if keypressed then
    begin
      znak:=readkey;
      if vstup then {funkce je dotazem na cislo}
      begin
	gotoxy(ask_x, ask_y);
	if (ord(znak) in [48..57]) and (cislo<6552) then
	cislo:=cislo*10 + (ord(znak)-48);
  	if ord(znak)=8 then cislo:=cislo div 10;
        write(#32:5);
	gotoxy(ask_x, ask_y);
    	if cislo>0 then write(cislo);
      end;
    end;
  cursor_off;
  if (znak<>#27) and vstup then ask:=cislo else ask:=0;
end;

function titulek(dotaz:string): t_polozka;
var
  znak: char;
  s: string;
begin
  cursor_on;
  gotoxy(52, titulek_y+1);
  znak:=#65;
  s:='';
  delete(dotaz, 26, 230); {muze byt zobrazeno jen prvnich 25 znaku}
  pis_polozku(titulek_y, dotaz, cerna, bila); {vypsani dotazu}
  while ((znak<>#13) and (znak<>#27) and (znak<>#32)) do
    if keypressed then
    begin
      znak:=readkey;
      gotoxy(52, titulek_y+1);
      if (ord(znak) in [32..126]) and (length(s)<26) then s:=s+znak;
      if ord(znak)=8 then delete(s,length(s),1);
      write(s);
      clreol;
    end;
  if znak<>#27 then titulek:=s else titulek:='';

  cursor_off;

  gotoxy(52, titulek_y);
  clreol;
  gotoxy(52, titulek_y+1);
  clreol;
end;

begin
end.