unit m_soubor;

interface

uses crt, m_ants, m_area;

{type
 }
{const }
procedure dosouboru(arena: t_area; mravci: t_ant_ptr; ulozit_co: byte);
{vytvori soubor s plochou, mravenci, nebo obojim}

function nacti_plochu(var arena:t_area; data_file: string): boolean;
{nacte ze souboru plochu}

function nacti_mravence(var ants: t_ant_ptr; data_file: string): boolean;
{nacte ze souboru mravence}

function over_nazev(s: string): boolean;
function file_exist(name: string): boolean;

implementation

uses
  dos, m_menu, m_tvga, m_tools, m_glob;

{const
 }
var
  f: text;

function over_nazev(s: string): boolean;
{povoli v nazvu souboru <8.3> jen pismena a cislice, jinak vrati ''.}
var
  i, delka: byte;
  spatny, tecka: boolean;
begin
  tecka:=FALSE;
  spatny:=FALSE;
  delka:=length(s);
  if delka>12 then
    spatny:=TRUE;

  for i:=1 to delka do
    if not (upcase(s[i]) in ['A'..'Z']) then
    begin
      if not (s[i] in ['0'..'9']) then
        if s[i]<>'.' then
          spatny:=TRUE;
    end;

  for i:=1 to delka do
    if s[i]='.' then
      if not tecka then
        tecka:=TRUE
      else
        spatny:=TRUE;

  if not spatny then
    over_nazev:=TRUE
  else
    over_nazev:=FALSE;
end;

function file_exist(name: string): boolean;
var
  f: file;
begin
  assign(f, name);
  {$I-}
  reset(f, 1);
  {$I+}
  file_exist:=ioresult=0;
end;

procedure get_filename(var filename: string; io: boolean);
{bezchybne zjisti jmeno souboru 'filename', 'io' urcuje, zda jde o}
{ukladaci soubor (jinak nacitaci). vraci prazdny retezec pri zruseni akce.}
var
  s: string;
  prepsat_anone: byte;
begin
  {filename:='mravci.dat';}
  filename:='';
  s:=titulek('Jmeno souboru:'); {jmeno souboru ve zkracenem tvaru}
  if s>'' {akce nezrusena} then
    if io then
    begin
      if over_nazev(s) then
      begin
        if file_exist(s) then
        begin
          {ask('Soubor jiz existuje. Prepsat ?');}
          write_text(52, 29, 7, 0, 'Soubor jiz existuje.');
          write_text(52, 30, 7, 0, 'Prepsat ?');
          dej_menu(menu_noyes, prepsat_anone);
          if prepsat_anone=2 then
            filename:=s
          else
            filename:='';
          write_text(52, 29, 7, 0, '                      ');
          write_text(52, 30, 7, 0, '         ');
        end else
            begin
              filename:=s;
            end;
      end else
          ask('Chybny nazev');
    end
    else
    begin
      if not file_exist(s) then
{      filename:=fsearch(s,'');
      if filename='' then}
        ask('Soubor nenalezen');
    end;
end;


procedure uloz_plochu(arena: t_area);
{ulozi plochu do souboru}
const
  digit: array[0..15] of char=('0', '1', '2', '3', '4', '5',
    '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
var
  ix,iy:byte;
  pom: byte;
begin
  writeln(f,'plocha=');
  for iy:=1 to area_height do
  begin
    for ix:=1 to area_width do
    begin
      pom:=(arena[ix,iy] and $DF);
      write(f, digit[pom div 16], digit[pom mod 16]);
    end;
    writeln(f);
  end;
  writeln(f);
  ask('Plocha ulozena ...');
end;

procedure uloz_mravence(ants: t_ant_ptr);
{ulozi mravence do souboru}
var
  neni_load: boolean;
  i: word;
  pomptr: t_ant_ptr;
begin
  neni_load:=1=0; { FALSE }
  writeln(f, 'mravenci=');
{  writeln(f, 'mravenci[x y smer rychlost]=');}
  pomptr:=ants;
  for i:=1 to ant_count do
  begin
    with pomptr^ do
    begin
      write(f, x:3, ' ', y:3, ' ', direction:3, ' ', speed:3, ' ',
        byte(neni_load):3);
      writeln(f);
    end;
    pomptr:=pomptr^.next;
  end;
  writeln(f, '###'); { uloz, ze je konec mravencu }
  writeln(f);
  ask('Mravenci ulozeni ...');
end;

procedure uloz_statistiku(m, v, p: word);
{ulozi zakladni statistiku do souboru}
var
  ix, iy: byte;
begin
  {m ... ant_count;}
  {v ... wood_count;}
  {p ... wood_carry;}
  writeln(f, '*** zakladni statistika ***');
  writeln(f, 'celkem mravencu: ', m);
  writeln(f, 'celkem vetvicek: ', v);
  write(f, 'z toho je prenaseno ', p, ' vetvicek,');
  writeln(f, ' coz je ', round(100*p/v), '% vsech vetvicek');
  writeln(f, 'tim je zamestnano ', round(100*p/m), '% mravencu');
  writeln(f, (v-p), ' vetvicek ceka na odnos');
  writeln(f, (m-p), ' mravencu nic nenese');
  writeln(f);
  ask('Statistika ulozena ...');
end;

procedure dosouboru(arena: t_area; mravci: t_ant_ptr; ulozit_co: byte);
{ vytvori soubor s plochou, mravenci, nebo obojim }
var
  data_file: string;
{  ulozit_co: byte;}
begin
{  dej_menu(menu_ulozit, ulozit_co);}
  get_filename(data_file, TRUE);
  if data_file>'' then
  begin
    assign(f, data_file);
    rewrite(f);
    writeln(f, 'Mravenci (c) 1999 - Datovy soubor');
    if (ulozit_co=1) or (ulozit_co=2) then uloz_plochu(arena);
    if (ulozit_co=1) or (ulozit_co=3) then uloz_mravence(mravci);

    uloz_statistiku(ant_count, wood_count, wood_carry);

    close(f);
  end;

{  ulozit_co:=1;}
{  while ulozit_co in [1..3] do
  begin
    dej_menu(menu_ulozit, ulozit_co);
    if ulozit_co in [1..3] then
    begin
      get_filename(data_file, 1=1);
      if data_file>'' then
      begin
        assign(f, data_file);
        rewrite(f);
        if (ulozit_co=1) or (ulozit_co=2) then uloz_plochu(arena);
        if (ulozit_co=1) or (ulozit_co=3) then uloz_mravence(mravci);
        uloz_statistiku(ant_count, wood_count, wood_carry);
        close(f);
      end;
    end;
  end;
}
end;

function nacti_plochu(var arena:t_area; data_file: string): boolean;
{nacte ze souboru plochu. je-li soubor poskozen,}
{je v 'arena[1,1]' vracena hodnota 32}
var
  s: string;
  s3: string[3];
  s2: string[2];
  nalezeno, chyba: boolean;
  ix, iy: byte;

  function hexdec(c: char): byte;
  begin
    case c of
      '0'..'9': hexdec:=ord(c)-ord('0');
      'A'..'F': hexdec:=ord(c)-55;
    end;
  end;

begin
  nalezeno:=FALSE;
  assign(f, data_file);
  reset(f);
  readln(f, s);
  if s='Mravenci (c) 1999 - Datovy soubor' then
  begin
    while not(eof(f) or nalezeno) do
    begin
      readln(f, s);
      if s='plocha=' then nalezeno:=TRUE;
    end;

    if nalezeno then
    begin
      chyba:=FALSE; {ted se hleda konec nacitanych dat}
      for iy:=1 to 50 do
        for ix:=1 to 51 do
          if not(chyba) then
          begin
            read(f, s2);
            if s2>'' then
            begin
              if (s2[1] in ['0'..'9', 'A'..'F']) and
                 (s2[2] in ['0'..'9', 'A'..'F']) then
              begin
                arena[ix,iy]:=hexdec(s2[1]) * 16 + hexdec(s2[2]);
              end else
                  begin
                    ask('Chyba v souboru !!!');
                    chyba:=TRUE;
                  end;
            end else
                readln(f);
          end;
      if chyba then
      begin
        arena[1,1]:=32;
        nacti_plochu:=FALSE;
      end else
          begin
            nacti_plochu:=TRUE;
          end;
    end else
        begin
          nacti_plochu:=FALSE;
        end;
  end else
      nacti_plochu:=FALSE;
  close(f);
end;

function nacti_mravence(var ants: t_ant_ptr; data_file: string): boolean;
{nacte ze souboru mravence}
{neni-li nacten alespon jeden mravenec, je vracena hodnota NIL}

var
  s: string;
  ok: byte;
  nalezeno: boolean;
  chyba: byte;
  x, y: integer;
  smer: integer;
  speed: integer;
  load: integer;

  function nacti_trojici(var data: integer; mezera: boolean): byte;
  var
    s3: string[3];
    code: integer;
    padding: char;
  begin
    if ok and $C0=$00 then
    begin { neni konec oblasti mravencu }
      read(f, s3);
      if s3<>'###' then
      begin
        val(s3, data, code);
        if code=0 then
        begin
          if mezera then
            read(f, padding);
          nacti_trojici:=1;
        end else
            nacti_trojici:=128; { chyba v souboru }
      end else
          begin
            nacti_trojici:=64; { konec mravencu }
          end;
    end;
  end;

begin
{  ant_count:=0;}
  assign(f, data_file);
  reset(f);
  readln(f, s);
  if s='Mravenci (c) 1999 - Datovy soubor' then
  begin
    nalezeno:=FALSE;
    while not (eof(f) or nalezeno) do
    begin
      readln(f,s);
{      if s='mravenci[x y smer rychlost]=' then nalezeno:=TRUE;}
      if s='mravenci=' then nalezeno:=TRUE;
    end;

    if nalezeno then
    begin
      ant_count:=0;
      repeat
        ok:=nacti_trojici(x, TRUE);
        ok:=ok or nacti_trojici(y, TRUE);
        ok:=ok or nacti_trojici(smer, TRUE);
        ok:=ok or nacti_trojici(speed, TRUE);
        ok:=ok or nacti_trojici(load, FALSE);
        if ok and $C0=$00 then
        begin
          add_ant(ants, x, y, smer, speed, boolean(load));
          inc(ant_count);
          readln(f, s);
        end;
      until (ok and $C0)<>00;

      if ok and 128=128 then
      begin
        deinit_ants(ants);
        ant_count:=0;
        { vrat chybu }
        nacti_mravence:=FALSE;
      end else
          begin
            { vrat OK }
            nacti_mravence:=TRUE;
          end;
    end else
        begin
          nacti_mravence:=FALSE;
        end;
  end else
      nacti_mravence:=FALSE;
  close(f);
end;

begin
end.