unit m_tvga;

interface

type
  t_rgb_entry = record
    r, g, b: byte;
  end;
  t_palette16 = array[0..15] of t_rgb_entry;

procedure cursor_off;
procedure cursor_on;

procedure write_text(x, y: byte; fore, back: byte; t: string);

procedure set_palette(first, count: byte; var palette);
{ nastavi 'count' barev pocinaje 'first' na hodnoty v buffer 'palette' }
procedure get_palette(first, count: byte; var palette);
{ ulozi 'count' barev pocinaje 'first' do bufferu 'palette' }

procedure get_palidx(var idxs);
{ vrati indexy do palety }
procedure set_palidx(var idxs);
{ nastavi indexy do palety podle 'idxs' }
procedure set_blink(status: byte);

implementation

type
  t_screen_cell = record
    ascii: byte;
    color: byte;
  end;

var
  screen: array[0..49, 0..79] of t_screen_cell absolute $B800:0000;

procedure cursor_off; assembler;
asm
  mov   ax, 40h
  mov   es, ax
  mov   di, 63h
  mov   dx, es:[di]
  mov   al, 0ah
  out   dx, al
  inc   dx
  in    al, dx
  or    al, 20h
  out   dx, al
end;

procedure cursor_on; assembler;
asm
  mov   ax, 40h
  mov   es, ax
  mov   di, 63h
  mov   dx, es:[di]
  mov   al, 0ah
  out   dx, al
  inc   dx
  in    al, dx
  and   al, 0DFh
  out   dx, al
end;

procedure set_blink(status: byte); assembler;
asm
  mov   ax, 1003h
  mov   bl, [status]
  int   10h
end;

procedure set_palette(first, count: byte; var palette); assembler;
{ nastavi 'count' barev pocinaje 'first' na hodnoty v buffer 'palette' }
asm
  push  ds

  lds   si, [palette]
  mov   dx, 03c8h
  mov   al, [first]
  out   dx, al
  xor   ch, ch
  mov   cl, [count]

  shl   cx, 1
  add   cl, [count]
  { vynasobim 3x, protoze RGB }
  mov   dx, 03c9h
@@loop1:
  lodsb
  out   dx, al
  loop  @@loop1

  pop   ds
end;

procedure get_palette(first, count: byte; var palette); assembler;
{ ulozi 'count' barev pocinaje 'first' do bufferu 'palette' }
asm
  les   di, [palette]
  mov   dx, 03c7h
  mov   al, [first]
  out   dx, al
  xor   ch, ch
  mov   cl, [count]

  shl   cx, 1
  add   cl, [count]
  { vynasobim 3x, protoze RGB }
  mov   dx, 03c9h
@@loop1:
  in    al, dx
  stosb
  loop  @@loop1
end;

procedure get_palidx(var idxs); assembler;
asm
  mov   ax, 1009h
  les   dx, [idxs]
  int   10h
end;

procedure set_palidx(var idxs); assembler;
asm
  mov   ax, 1002h
  les   dx, [idxs]
  int   10h
end;

procedure write_text(x, y: byte; fore, back: byte; t: string);
{ na x,y napise 't' barvou 'fore' a 'back' }
var
  offset: word;
  color: byte;
  i: byte;
begin
  color:=back shl 4 + fore;
  for i:=0 to length(t)-1 do
  begin
    screen[(y-1), (x-1)+i].ascii:=byte(t[i+1]);
    screen[(y-1), (x-1)+i].color:=color;
  end;
end;

begin
end.