unit UGrafika; {Graficka knihovna k programu Fotbal '99 - tym Stanek, Sip, Machaty}

interface

{Zakladni volaci procedura}
procedure Start (ADelka, AVyska: Byte; Jmeno1, Jmeno2: string; AObsazeni, AZacina, ATvar, ADelkaBrany, AZpomaleni: Byte);
procedure Clovek (var X, Y: Byte); {procedura typu THrac}
procedure Stroj (var X, Y: Byte); {procedura typu THrac}

implementation

uses CRT, Graph, Typy, U_Fotbal;

type
   THrac = procedure (var X, Y: Byte); {Imaginarni hrac - bud clovek, nebo stroj}
   TZaloha = record {Zaloha obrazovky pod puntikem}
      X, Y: Integer;
      Obrazek: Pointer;
   end;

var
   Hriste: PPole;
   Segment, Offset: Word;
   Obsazeni, Delka, Vyska, Krok, Zacina, Tvar, AktualniX, AktualniY, DelkaBrany, Vitez, Zpomaleni: Byte;
   Jmena: array [1..2] of string;
   Hraci: array [1..2] of THrac;
   Brany: array [1..2] of PBrana;
   Gol, Konec, Chyba, Pozor: Boolean;
   Zaloha: TZaloha;

procedure NastavUzel (X, Y, Hodnota: Byte); {Nastavi uzel hriste}
var W: Word;
begin
   W := Delka * (Y - 1) + X - 1;
   Mem [Segment:Offset + W] := Hodnota;
end;

procedure GenerujHriste; {Generuje hriste v zavislosti na tvaru}
var I, J, A: Byte;
begin
   if Tvar = 0 then begin
      for I := 2 to Delka - 1 do begin
         NastavUzel (I, 1, $F1);
         NastavUzel (I, Vyska, $1F);
      end;
      for I := 2 to Vyska - 1 do begin
         NastavUzel (1, I, $7C);
         NastavUzel (Delka, I, $C7);
      end;
      NastavUzel (1, 1, $FD);
      NastavUzel (Delka, 1, $F7);
      NastavUzel (1, Vyska, $7F);
      NastavUzel (Delka, Vyska, $DF);
      for I := 2 to Delka - 1 do for J := 2 to Vyska - 1 do NastavUzel (I, J, $00);
   end else begin
      A := Delka div 2 + 1;
      for I := 1 to Delka do for J := 1 to Vyska do NastavUzel (I, J, $FF);
      for I := A to Delka do begin
         NastavUzel (I, I - A + 1, $E3);
         NastavUzel (I, Delka - (I - A), $8F);
      end;
      for I := 1 to A do begin
         NastavUzel (I, A - I + 1, $F8);
         NastavUzel (I, A + I - 1, $3E);
      end;
      for I := A + 1 to Delka do begin
         NastavUzel (I, I - A, $F7);
         NastavUzel (I, Delka - (I - A - 1), $DF);
      end;
      for I := 1 to A - 1 do begin
         NastavUzel (I, A - I, $FD);
         NastavUzel (I, A + I, $7F);
      end;
      for I := 1 to A do for J := 1 to I - 1 do begin
         NastavUzel (I, A - J + 1, $00);
         NastavUzel (I, A + J - 1, $00);
      end;
      for I := A to Delka do for J := Delka - I downto 1 do begin
         NastavUzel (I, A - J + 1, $00);
         NastavUzel (I, A + J - 1, $00);
      end;
      NastavUzel (A, 1, $FB);
      NastavUzel (Delka, A, $EF);
      NastavUzel (A, Delka, $BF);
      NastavUzel (1, A, $FE);
   end;
end;

procedure PridejUzelBrany (Ktera, X, Y: Byte); {Prida bod do spojoveho seznamu brany}
var P: PBrana;
begin
   New (P);
   P^.X := X;
   P^.Y := Y;
   if Brany [Ktera] = nil then begin
      P^.Predchozi := P;
      P^.Dalsi := P
   end else begin
      P^.Predchozi := Brany [Ktera];
      P^.Dalsi := Brany [Ktera]^.Dalsi;
      Brany [Ktera]^.Dalsi := P;
   end;
   Brany [Ktera] := P;
end;

procedure GenerujBrany; {Generuje obe brany}
var XStart, I: Byte;
begin
   if Tvar = 0 then begin
      XStart := (Delka - DelkaBrany) div 2;
      for I := 1 to DelkaBrany do begin
         PridejUzelBrany (1, XStart + I, 1);
         PridejUzelBrany (2, XStart + I, Vyska);
      end;
   end else begin
      XStart := ((Delka div 2) - DelkaBrany) div 2 + 1;
      for I := 1 to DelkaBrany do begin
         PridejUzelBrany (1, Delka div 2 + XStart + I, XStart + I);
         PridejUzelBrany (2, XStart + I, Delka div 2 + XStart + I);
      end;
   end;
end;

function VratUzel (X, Y: Byte): Byte; {Vrati uzel hriste}
var W: Word;
begin
   W := Delka * (Y - 1) + X - 1;
   VratUzel := Mem [Segment:Offset + W];
end;

function ProverSmer (X, Y, Smer: Byte): Boolean; {Proveri smery uzlu}
const Hodnoty: array [1..8] of Byte = (1, 2, 4, 8, 16, 32, 64, 128);
begin
   if VratUzel (X, Y) and Hodnoty [Smer] = Hodnoty [Smer] then ProverSmer := True else ProverSmer := False;
end;

procedure ZobrazTah (X1, Y1: Integer; Smer: Byte); {Zobrazi jeden smer}
begin
   case Smer of
      1: Line (X1, Y1, X1 + Krok, Y1);
      2: Line (X1, Y1, X1 + Krok, Y1 + Krok);
      3: Line (X1, Y1, X1, Y1 + Krok);
      4: Line (X1, Y1, X1 - Krok, Y1 + Krok);
      5: Line (X1, Y1, X1 - Krok, Y1);
      6: Line (X1, Y1, X1 - Krok, Y1 - Krok);
      7: Line (X1, Y1, X1, Y1 - Krok);
      8: Line (X1, Y1, X1 + Krok, Y1 - Krok);
   end;
end;

procedure ZobrazUzel (X, Y: Byte); {Zobrazi jeden uzel - vsechny smery}
var
   XStart, YStart: Integer;
   I: Byte;
begin
   XStart := (X - 1) * Krok;
   YStart := (Y - 1) * Krok;
   SetColor (White);
   for I := 1 to 8 do if ProverSmer (X, Y, I) then ZobrazTah (XStart, YStart, I);
end;

procedure ZobrazBranu (Ktera: Byte); {Zobrazi vybranou branu}
var X, Y, I: Byte;
begin
   X := Brany [Ktera]^.X;
   Y := Brany [Ktera]^.Y;
   Brany [Ktera] := Brany [Ktera]^.Dalsi;
   MoveTo ((X - 1) * Krok, (Y - 1) * Krok);
   SetColor (LightGreen);
   for I := 1 to DelkaBrany do begin
      LineTo ((Brany [Ktera]^.X - 1) * Krok, (Brany [Ktera]^.Y - 1) * Krok);
      Brany [Ktera] := Brany [Ktera]^.Dalsi;
   end;
end;

procedure ZobrazNapis (Y: Integer; Napis: string); {Zobrazi vycentrovany text}
var W: Word;
begin
   W := (GetMaxX + 1 - Length (Napis) * 8) div 2 - 1;
   OutTextXY (W, Y, Napis);
end;

procedure ZobrazPodklad; {Zobrazi ramecky, podklad}
begin
   SetColor (Blue);
   Rectangle (0, 0, GetMaxX, GetMaxY);
   SetFillStyle (SolidFill, Blue);
   Bar (0, 0, GetMaxX, 11);
   SetFillStyle (SolidFill, LightGray);
   Bar (1, 12, GetMaxX - 1, GetMaxY - 1);
   SetColor (Blue);
   Line (0, GetMaxY - 12, GetMaxX, GetMaxY - 12);
   SetColor (White);
   ZobrazNapis (2, '***** Fotbal ''99 *****');
end;

procedure NastavOkno; {Definuje podokno pro hriste}
var X1, Y1, X2, Y2: Word;
begin
   X1 := (GetMaxX - ((Delka - 1) * Krok)) div 2;
   Y1 := (GetMaxY - ((Vyska - 1) * Krok)) div 2;
   X2 := X1 + (Delka - 1) * Krok;
   Y2 := Y1 + (Vyska - 1) * Krok;
   SetViewPort (X1, Y1, X2, Y2, True);
end;

procedure Natahni; {"Natahne" podokno pro pripadny puntik...}
var Hodnoty: ViewPortType;
begin
   GetViewSettings (Hodnoty);
   with Hodnoty do SetViewPort (X1 - 5 , Y1 - 5, X2 + 5, Y2 + 5, False);
end;

procedure Stahni; {... Vrati vse do normalu}
var Hodnoty: ViewPortType;
begin
   GetViewSettings (Hodnoty);
   with Hodnoty do SetViewPort (X1 + 5, Y1 + 5, X2 - 5, Y2 - 5, True);
end;

procedure ZobrazBod; {Puntik, zalohuje se, co je pod nim}
var
   XStart, YStart: Integer;
   Poprve: Boolean;
begin
   XStart := (AktualniX - 1) * Krok;
   YStart := (AktualniY - 1) * Krok;
   Poprve := False;
   with Zaloha do begin
      if Obrazek = nil then begin
         Poprve := True;
         GetMem (Obrazek, ImageSize (XStart - 3, YStart - 3, XStart + 3, YStart + 3));
      end;
      Natahni;
      GetImage (5 + XStart - 3, 5 + YStart - 3, XStart + 3 + 5, YStart + 3 + 5, Obrazek^);
      X := XStart - 3;
      Y := YStart - 3;
   end;
   SetFillStyle (SolidFill, LightRed);
   SetColor (LightRed);
   FillEllipse (5 + XStart, 5 + YStart, 3, 3);
   Stahni;
   if (not Poprve) and (not Gol) then begin
      Sound (100);
      Delay (100);
      NoSound;
   end;
end;

procedure SmazStaryBod; {Prekresli neaktualni puntik}
begin
   with Zaloha do if Obrazek <> nil then begin
      Natahni;
      PutImage (X + 5, Y + 5, Obrazek^, NormalPut);
      Stahni;
   end;
end;

procedure ZobrazHriste; {Vola jednotlive procedury ZobrazXXXXX}
var
   I, J: Byte;
   Rozmery: ViewPortType;
begin
   ZobrazPodklad;
   NastavOkno;
   SetFillStyle (SolidFill, DarkGray);
   Bar (0, 0, (Delka - 1) * Krok, (Vyska - 1) * Krok);
   SetColor (LightGray);
   for I := 0 to Delka - 1 do Line (I * Krok, 0, I * Krok, (Vyska - 1) * Krok);
   for I := 0 to Vyska - 1 do Line (0, I * Krok, (Delka - 1) * Krok, I * Krok);
   for I := 1 to Delka do for J := 1 to Vyska do ZobrazUzel (I, J);
   for I := 1 to 2 do ZobrazBranu (I);
   ZobrazBod;
   GetViewSettings (Rozmery);
   SetViewPort (0, 0, GetMaxX, GetMaxY, True);
   SetColor (Black);
   ZobrazNapis (Rozmery.Y1 - 9, Jmena [1]);
   ZobrazNapis (Rozmery.Y2 + 2, Jmena [2]);
   NastavOkno;
end;

procedure NastavKrok; {Generuje akoratni krok}
begin
   if (GetMaxX / Delka) < (GetMaxY / Vyska) then Krok := (GetMaxX - 2) div Delka else Krok := (GetMaxY - 30) div Vyska;
end;

procedure Zprava (Textik: string); {Informace pro uzivatele v dolni casti obrazovky}
begin
   SetViewPort (0, 0, GetMaxX, GetMaxY, True);
   SetFillStyle (SolidFill, LightGray);
   Bar (1, GetMaxY - 11, GetMaxX - 1, GetMaxY - 1);
   SetColor (Black);
   ZobrazNapis (GetMaxY - 10, Textik);
   NastavOkno;
end;

procedure ProhodBrany; {Nekdy je to dobre...}
var Brana: PBrana;
begin
   if ((Obsazeni = 0) and (Zacina = 0)) or (Obsazeni = 2) then begin
      Brana := Brany [1];
      Brany [1] := Brany [2];
      Brany [2] := Brana;
   end;
end;

function Pruchodny (X, Y: Byte): Boolean; {Je uzel pruchodny?}
var I, Pocet: Byte;
begin
   Pocet := 0;
   for I := 1 to 8 do if ProverSmer (X, Y, I) = False then Inc (Pocet);
   if Pocet > 1 then Pruchodny := True else Pruchodny := False;
end;

procedure Beh; {Hlavni smycka}
begin
   while ((not Gol) and (not Chyba) and (not Konec)) do begin
      Zprava ('Hraje ' + Jmena [1]);
      Hraci [1] (AktualniX, AktualniY);
      if ((not Gol) and (not Chyba) and (not Konec) and (not Pruchodny (AktualniX, AktualniY))) then begin
         Gol := True;
         Chyba := True;
      end;
      if ((not Gol) and (not Chyba) and (not Konec)) then begin
         Zprava ('Hraje ' + Jmena [2]);
         ProhodBrany;
         Pozor := True;
         Hraci [2] (AktualniX, AktualniY);
         Pozor := False;
         ProhodBrany;
         if ((not Gol) and (not Chyba) and (not Konec) and (not Pruchodny (AktualniX, AktualniY))) then begin
            Gol := True;
            Chyba := True;
         end;
      end;
   end;
end;

procedure Vyhodnoceni; {K cemu doslo?}
var I: Byte;
begin
   if Gol and Chyba then Zprava ('Dale nelze hrat - remiza! Stisknete klavesu Enter')
   else if Chyba then Zprava ('Vyhodnocovaci algoritmus stroje vratil chybu! Stisknete klavesu Enter')
   else if Gol then begin
      for I := 1 to 2 do ZobrazBranu (I);
      ZobrazBod;
      Vitez := Vitez mod 2 + 1;
      Zprava ('Gol! Vitez: ' + Jmena [Vitez] + '. Stisknete klavesu Enter');
   end else Exit;
   repeat
   until KeyPressed;
end;

procedure Uvolni; {Dealokace pameti}
var
   I, J: Byte;
   P: PBrana;
begin
   for I := 1 to 2 do for J := 1 to DelkaBrany do begin
      P := Brany [I]^.Dalsi;
      Dispose (Brany [I]);
      Brany [I] := P;
   end;
   Brany [1] := nil;
   Brany [2] := nil;
   FreeMem (Hriste, Delka * Vyska);
   FreeMem (Zaloha.Obrazek, SizeOf (Zaloha.Obrazek));
   Zaloha.Obrazek := nil;
end;

procedure Start (ADelka, AVyska: Byte; Jmeno1, Jmeno2: string; AObsazeni, AZacina, ATvar, ADelkaBrany, AZpomaleni: Byte);
var Pomocna: THrac;
begin
   Delka := ADelka;
   Vyska := AVyska;
   GetMem (Hriste, Delka * Vyska);
   Segment := Seg (Hriste^);
   Offset := Ofs (Hriste^);
   Jmena [1] := Jmeno1;
   Jmena [2] := Jmeno2;
   Obsazeni := AObsazeni;
   case Obsazeni of
      0: begin
         Hraci [1] := Clovek;
         Hraci [2] := Stroj;
      end;
      1: begin
         Hraci [1] := Clovek;
         Hraci [2] := Clovek;
      end;
      2: begin
         Hraci [1] := Stroj;
         Hraci [2] := Stroj;
      end;
   end;
   Zacina := AZacina;
   if Zacina = 1 then begin
      Pomocna := Hraci [1];
      Hraci [1] := Hraci [2];
      Hraci [2] := Pomocna;
      Jmena [1] := Jmena [2];
      Jmena [2] := Jmeno1;
      ProhodBrany;
   end;
   Tvar := ATvar;
   DelkaBrany := ADelkaBrany;
   Zpomaleni := AZpomaleni;
   AktualniX := Delka div 2 + 1;
   AktualniY := Vyska div 2 + 1;
   Gol := False;
   Chyba := False;
   Konec := False;
   Pozor := False;
   NastavKrok;
   GenerujHriste;
   GenerujBrany;
   ZobrazHriste;
   Beh;
   Vyhodnoceni;
   Uvolni;
end;

procedure PrekryjUzel (X, Y, Hodnota: Byte); {Prekryje uzel novym tahem}
var
   B: Byte;
   W: Word;
begin
   B := VratUzel (X, Y);
   W := Delka * (Y - 1) + X - 1;
   Mem [Segment:Offset + W] := B or Hodnota;
end;

function Odraz (X, Y: Byte): Boolean; {Pujde se dal?}
var I, Pocet: Byte;
begin
   Pocet := 0;
   for I := 1 to 8 do if ProverSmer (X, Y, I) then Inc (Pocet);
   if Pocet > 0 then Odraz := True else Odraz := False;
end;

procedure OsetriGol; {Byl dan gol?}
var I, J, X, Y: Byte;
begin
   if Pozor then ProhodBrany;
   for I := 1 to 2 do for J := 1 to DelkaBrany do begin
      if (AktualniX = Brany [I]^.X) and (AktualniY = Brany [I]^.Y) then begin
         Gol := True;
         Vitez := I;
      end;
      Brany [I] := Brany [I]^.Dalsi;
   end;
   if Pozor then ProhodBrany;
end;

procedure Clovek (var X, Y: Byte);
var
   Klavesa: Char;
   Smer, A, B: Byte;
   Dale: Boolean;
const Hodnoty: array [1..8] of Byte = (1, 2, 4, 8, 16, 32, 64, 128);
begin
   repeat
      Klavesa := ReadKey;
   until Klavesa in ['6', '3', '2', '1', '4', '7', '8', '9', 'k', 'K'];
   case Klavesa of
      '6': Smer := 1;
      '3': Smer := 2;
      '2': Smer := 3;
      '1': Smer := 4;
      '4': Smer := 5;
      '7': Smer := 6;
      '8': Smer := 7;
      '9': Smer := 8;
      'k', 'K': Konec := True;
   end;
   if not Konec then begin
      A := X;
      B := Y;
      case Smer of
         8, 1, 2: Inc (A);
         4, 5, 6: Dec (A);
      end;
      case Smer of
         2, 3, 4: Inc (B);
         6, 7, 8: Dec (B);
      end;
      if (ProverSmer (X, Y, Smer) = False) and Pruchodny (A, B) then begin
         SmazStaryBod;
         PrekryjUzel (X, Y, Hodnoty [Smer]);
         ZobrazUzel (X, Y);
         if Odraz (A, B) then Dale := True else Dale := False;
         PrekryjUzel (A, B, Hodnoty [(Smer + 4) mod 8]);
         X := A;
         Y := B;
         ZobrazBod;
         OsetriGol;
         if Dale and not Gol then Clovek (X, Y);
      end else begin
         Sound (1000);
         Delay (100);
         NoSound;
         Clovek (X, Y);
      end;
   end;
end;

procedure Stroj (var X, Y: Byte);
var
   Smer: Integer;
   I, J, A, B: Byte;
   Dale: Boolean;
const Hodnoty: array [1..8] of Byte = (1, 2, 4, 8, 16, 32, 64, 128);
begin
   SmazStaryBod;
   for I := 1 to 2 do for J := 1 to DelkaBrany do begin
      Dec (Brany [I]^.X);
      Dec (Brany [I]^.Y);
      Brany [I] := Brany [I]^.Dalsi;
   end;
   Smer := R2Tah (Hriste, Delka, Vyska, X - 1, Y - 1, Brany [1], Brany [2], 0);
   for I := 1 to 2 do for J := 1 to DelkaBrany do begin
      Inc (Brany [I]^.X);
      Inc (Brany [I]^.Y);
      Brany [I] := Brany [I]^.Dalsi;
   end;
   if Smer < 0 then Chyba := True else begin
      for A := 1 to 8 do if Hodnoty [A] = Smer then B := A;
      Smer := B;
      PrekryjUzel (X, Y, Hodnoty [Smer]);
      case Smer of
         8, 1, 2: Inc (X);
         4, 5, 6: Dec (X);
      end;
      case Smer of
         2, 3, 4: Inc (Y);
         6, 7, 8: Dec (Y);
      end;
      if Odraz (X, Y) then Dale := True else Dale := False;
      PrekryjUzel (X, Y, Hodnoty [(Smer + 4) mod 8]);
      ZobrazUzel (X, Y);
      ZobrazBod;
      OsetriGol;
      Delay (Zpomaleni * 250);
      if Dale and not Gol then Stroj (X, Y);
   end;
end;

end.