#include "bits.hpp"


BitOutput::BitOutput(char *name)
{
  _file = fopen(name, "wb");
  buflen = 0;
}

BitOutput::~BitOutput()
{
  if (buflen > 0)
  {
    buf &= 0xFF >> (8 - buflen);  // nechame jen platne bity
    fputc((char)buf, _file);
  }
  fclose(_file);
}

void BitOutput::Write(ushort w, int n)
{
  ulong x;
  int xlen;

  x = buf & (0xFF >> (8 - buflen));
  x |= (ulong)w << buflen;
  xlen = buflen + n;
  while (xlen >= 8)
  {
    fputc((char)x, _file);
    x = x >> 8;
    xlen -= 8;
  }
  buf = (uchar)x;
  buflen = xlen;
}

BitInput::BitInput(char *name)
{
  _file = fopen(name, "rb");
  buflen = 0;
}

BitInput::~BitInput()
{
  fclose(_file);
}

int BitInput::Read(ushort &w, int n)
{
  ulong x;
  int xlen;
  uchar t;

  x = buf & (0xFF >> (8 - buflen));  // nechame je platne bity
  xlen = buflen;
  while (n > xlen)
  {
    t = fgetc(_file);
    x |= (ulong)t << xlen;
    xlen += 8;
  }
  buf = x >> n;
  buflen = xlen - n;
  w = (ushort)x & (0xFFFF >> (16 - n));  // nechame jen platne bity
  return feof(_file);
}


