#include "bits.hpp"

const int IC = 256;  // je treba inicializovat tabulku
const int EC = 257;  // konec souboru
const int FF = 258;  // prvni volny

const int SIZE = 4096;  // velikost tabulky pro 12 bitu
const int BADI = -1;  // neplatny index

typedef struct {
  uchar val;  // hodnota znaku
  int prev;  // predchazejici clen retezce
} TABLEITEM;

typedef TABLEITEM TABLE[SIZE];

class Decoder
// dekoduje lzw
{
  public:
    Decoder(BitInput *i);
    // i - bitovy vstup
    int GetValue(uchar &value);
    // dekoduje znak a ulozi ho do promenne value
    // vraci: 0 - konec souboru, jinak vporadku
  private:
    TABLE tab; // (de)komprimacni tabulka
    int firstfree; // prvni volna polozka v tabulce
    int width; // velikost kodu v bitech
    uchar stack[SIZE]; // vystupni buffer
    int sp; // pozice ve vystupnim bufferu
    uchar firstval; // hodnota prvniho znaku v dekodovanem retezci
    ushort code; // aktualni kod
    ushort oldcode; // predchazejici kod
    void InitTable(); // inicializace tabulky
    int ReadCode(); // prevede kod na retezec nebo IC, EC
    void AddItem(); // prida polozku do tabulky
    int state_add; // indikator zda je mozno pridavat do tabulky
    int state_err; // indikator chyby, konce souboru, EC
    BitInput *_file; // handle souboru
};
