#include "encoder.hpp"

Encoder::Encoder(BitOutput *o)
{
  _file = o;
  InitTable();
  state_fst = 0;
  position = IC;
}

Encoder::~Encoder()
{
  _file->Write(position, width);
  _file->Write(EC, width);
}

void Encoder::InitTable()
{
  int i;
  firstfree = FF;
  width = 9;
  for (i = 0; i < IC; i++)
  {
    tab[i].val = i;
    tab[i].next = BADI;
    tab[i].prto = BADI;
  }
}

void Encoder::PutValue(uchar value)
{
  int newpos, prevpos;
  if (state_fst == 0)
  {
    state_fst = 1;
    _file->Write(position, width);
    position = value;
    return;
  }
  newpos = tab[position].prto;
  prevpos = BADI;
  while (newpos != BADI)
  {
    if (tab[newpos].val == value)
    {
      position = newpos;
      return;
    }
    prevpos = newpos;
    newpos = tab[newpos].next;
  }
  _file->Write(position, width);
  if (firstfree >= SIZE)
  {
    _file->Write(IC, width);
    InitTable();
  }
  else
  {
    tab[firstfree].val = value;
    tab[firstfree].next = BADI;
    tab[firstfree].prto = BADI;
    if (tab[position].prto != BADI)
      tab[prevpos].next = firstfree;
    else
      tab[position].prto = firstfree;
    firstfree++;
    if (firstfree > (1 << width))
      width++;
  }
  position = value;
}
