#include "bits.hpp"

const int IC = 256;  // je treba inicializovat tabulku
const int EC = 257;  // konec souboru
const int FF = 258;  // prvni volny

const int SIZE = 4096;  // velikost tabulky pro 12 bitu
const int BADI = -1;  // neplatny index

typedef struct {
  uchar val;  // hodnota znaku
  int next;  // dalsi se stejnym prefixem
  int prto;  // prvni, ke ktremu je prefixem
} TABLEITEM;

typedef TABLEITEM TABLE[SIZE];

class Encoder
// koduje pomoci lzw
{
  public:
    Encoder(BitOutput *o);
    // o - bitovy vystup
    ~Encoder();
    void PutValue(uchar value);
    // zakoduje hodnotu value
  private:
    TABLE tab; // komprimacni tabulka
    int firstfree; // prvni volna polozka v tabulce
    int position; // aktualni pozice v tabulce
    int width; // sirka kodu v bitech
    int state_fst; // indikator prvniho kodovaneho znaku
    void InitTable(); // inicializace tabulky
    BitOutput *_file; // handle souboru
};
