Unit U_Fotbal;

{***************************************************************************}
{   INTERFACE}
{***************************************************************************}

Interface
Uses Typy;

Function R2Tah(Hriste: PPole; Dx, Dy, X, Y: Integer; BVlastni, BSoupere: PBrana; Cas: Longint): Integer;

{***************************************************************************}
{   IMPLEMENTATION}
{***************************************************************************}

Implementation

Type PPozice = ^TPozice; {seznam moznych koncovych souradnic}
     TPozice = record
        x, y: Integer;
        Hodnota: Byte;    {od [X,Y]}
        Vlastni, Souper: Byte;
        Dalsi: PPozice;
     end;

     PTah = ^TTah;       {vysledny seznam tahu}
     TTah = record       {vuzivan i pri cislovani hriste}
        Smer: Byte;
        Dalsi: PTah;
     end;

     PSouradnice = ^TSouradnice;  {vyuzivan pri cislovani hriste}
     Tsouradnice = record
        x, y: Integer;
        Dalsi: PSouradnice;
     end;

const SmerXY: array [1..8, 1..2] of ShortInt = (( 1, 0),( 1, 1),( 0, 1),(-1, 1),
                                                (-1, 0),(-1,-1),( 0,-1),( 1,-1));

var PrioritaSmeru, PoradiSmeru: array [1..8] of Byte;
    SeznamTahu: Ptah;
    Poprve, PametOK: Boolean;



{TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT}
{TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT}

Function AlokujHriste(Velikost: Word): Pointer;
   var P: Pointer;
   begin
      if memavail < Velikost then P:= nil else GetMem(P, Velikost);
      AlokujHriste:= P;
   end;

Procedure UvolniHriste(var Hriste: PPole; Velikost: Word);
   begin
      FreeMem(Hriste, Velikost);
      Hriste:= nil;
   end;

Procedure VyplnPamet(Ukazatel: Pointer; Cim: Byte; Pocet: Word);
   var Ofset, Segment: Word;
   begin
      Ofset:= ofs(Ukazatel^);
      Segment:= seg(Ukazatel^);
      asm
         mov ax, Segment
         mov es, ax
         mov bx, Ofset
         mov di, bx
         mov al, Cim
         mov cx, Pocet
         rep stosb
      end;
   end;

Function SpojByty(Nizsi, Vyssi: Byte): Word;
   var W, Ofset, Segment: Word;
   begin
      Segment:= seg(W);
      Ofset:= ofs(W);
      mem[Segment: Ofset]:=Nizsi;
      mem[Segment: Ofset+1]:=Vyssi;
      SpojByty:= W;
   end;

Function Interval(c,min,max:longint):longint; {i=11 interval(i-3,10,15)=14}
   begin
      if c<min then c:=c+((min-c-1) div (max-min+1)+1)*(max-min+1);
      if c>max then c:=c-((c-max-1) div (max-min+1)+1)*(max-min+1);
      Interval:=c;
   end;

{TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT}
{TTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTTT}


{PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP}
{PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP}

Function PrevedMujSmer(Smer: Byte): Byte;
{Muj smer: 1..8 => chci 1,2,4,8,..128}
{Tzn Pom:=1 (pravy bit je 1) chci ho posunout o (Smer-1) doleva}
   var Pom, i: Byte;
   begin
      Pom:= 1;
      Pom:= Pom shl (Smer-1);
      PrevedMujSmer:= Pom;
   end;

Function PrevedBitSmer(Smer: Byte): Byte;
{Prevede smer na 1..8 z 1,2,4..}
   var Pom, i: Byte;
   begin
      Pom:= 1;
      for i:= 1 to 8 do begin
         if (Smer and Pom) <> 0 then PrevedBitSmer:= i;
         Pom:= Pom shl 1;
      end;
   end;

Function JeVolnySmer(Uzel, Smer: Byte): Boolean;
{Smer je 1..8}
   begin
      Uzel:= Uzel shr (Smer-1);
      if (Uzel and 1) = 0 then JeVolnySmer:= True else JeVolnySmer:= False;
   end;

Function MujOpacnySmer(Smer: Byte): Byte;
{Smer je 1..8}
   begin
      Smer:= Interval(Smer + 4, 1, 8);
      MujOpacnySmer:= Smer;
   end;

Function VzdalenostAB(Ax, Ay, Bx, By: Real): Real;
   var Vzdal: Real;
   begin
      Vzdal:= sqrt(sqr(Ax-Bx) + sqr(Ay-By));
      VzdalenostAB:= Vzdal;
   end;

Function CtiZeHriste(Hriste: PPole; Dx, Dy, X, Y: Integer): Byte;
   begin
      CtiZeHriste:= Mem[seg(Hriste^): ofs(Hriste^) + (Y*DX) + X];
   end;

Procedure ZapisDoHriste(Hriste: PPole; Dx, Dy, X, Y: Integer; Co: Byte);
   begin
      Mem[seg(Hriste^): ofs(Hriste^) + (Y*DX) + X]:= Co;
   end;

Function PocetVychozichCest(Uzel: Byte): Byte;
   var Pocet, i: Byte;
   begin
      Pocet:= 0;
      for i:= 1 to 8 do begin
         if (Uzel and 1) = 0 then Pocet:=Pocet+1;
         Uzel:= Uzel shr 1;
      end;
      PocetVychozichCest:= Pocet;
   end;

Function JeToBrana(Zacatek: PBrana; x, y: Integer): Boolean;
   var Pom: PBrana;
   begin
      JeToBrana:= false;
      Pom:= Zacatek;
      repeat
         if (Pom^.x = x) and (Pom^.y = y) then JeToBrana:= true;
         Pom:= Pom^.Dalsi;
      until Pom = Zacatek;
   end;

Function Precti3Bity(Cislo: Byte): Byte;
{vraci cislo 1..8 prectene v bytu na 1..3 bitu zleva}
   begin
      Precti3Bity:= (Cislo shr 5) + 1;
   end;

Function Precti5Bitu(Cislo: Byte): Byte;
{vraci cislo 1..8 prectene v bytu na 4..8 bitu zleva}
   begin
      Precti5Bitu:= Cislo and 31;
   end;

Function Pripis3Bity(Cis, Cislo1_8: Byte): Byte;
{vraci byte kam na pozice 6..8 bitu zapsal cislo 1..8}
   begin
      Cislo1_8:= (Cislo1_8-1) shl 5;
      Pripis3Bity:= Cis or Cislo1_8;
   end;

Function Pripis5Bitu(Cis, Cislo0_31: Byte): Byte;
   begin
      Pripis5Bitu:= Cis or Cislo0_31;
   end;

Function Pripis3a5Bitu(cis3, cis5: Byte): Byte;
   begin
      Pripis3a5Bitu:= Pripis5Bitu(Pripis3Bity(0, cis3), cis5);
   end;


Procedure Pridej_SPozice(var Zacatek: PPozice; x, y: Integer; Hodnota, Vlastni, Souper: Byte);
   var Pozice: PPozice;
   begin
      if MemAvail > SizeOf(Pozice) then begin
         New(Pozice);
         Pozice^.Dalsi:= Zacatek;
         Pozice^.x:= x;
         Pozice^.y:= y;
         Pozice^.Hodnota:= Hodnota;
         Pozice^.Vlastni:= Vlastni;
         Pozice^.Souper:= Souper;
         Zacatek:= Pozice;
      end else begin
         PametOK:= False;
      end;
   end;

Procedure Uvolni_SPozice(var Zacatek: PPozice);
   var Pom: PPozice;
   begin
      while Zacatek<>nil do begin
         Pom:= Zacatek;
         Zacatek:= Zacatek^.Dalsi;
         Dispose(Pom);
      end;
   end;

Procedure PridejTahSeznam(var Zacatek: PTah; Smer: Byte);
   var PomTah: PTah;
   begin
      if MemAvail > SizeOf(PomTah) then begin
         New(PomTah);
         PomTah^.Dalsi:= Zacatek;
         Zacatek:= PomTah;
         PomTah^.Smer:= Smer;
      end else PametOK:= False;
   end;

Function PrectiAUvolniMujTah(var Zacatek: PTah): Byte;
   var PomTah: PTah;
       Smer: Byte;
   begin
      Smer:= 0;
      if Zacatek<>nil then begin
         Smer:= Zacatek^.Smer;
         PomTah:= Zacatek;
         Zacatek:= Zacatek^.Dalsi;
         Dispose(PomTah);
      end;
      PrectiAUvolniMujTah:= Smer;
   end;

{PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP}
{PPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPPP}


Procedure TabulkaPrioritySmeru(Zacatek: PBrana; X, Y: Integer);
{Pro kazdy smer vytvori soucet vzdalenosti ke vsem branam a vyhodnoti podle}
{toho prioritni smer}
   var Vzdalenost: array [1..8] of Real;
       i: Byte;
       Pom: PBrana;

   Procedure VyhodnotBranu(Bx, By: Integer);
   {Vypocita podle Pyth. vety vzdalenost k zadane brane pro vsechny smery a}
   {pripocita vysledky k souctum v tabulce Vzdalenost[i]}
       var i: Byte;
           Vzdal: Real;
       begin
          for i:= 1 to 8 do begin
             Vzdal:= VzdalenostAB(X+SmerXY[i,1], Y+SmerXY[i,2], Bx, By);
             Vzdalenost[i]:= Vzdalenost[i] + Vzdal;
          end;
       end;

   Procedure VyhodnotTabulku;
      var i, Nejmensi: Byte;
          WPom: Word;

      Function VedlejsiSmer(Smer: Byte): Word;
         var Smer1, Smer2: Byte;
         begin
            Smer1:= Interval(Smer - 1, 1, 8);
            Smer2:= Interval(Smer + 1, 1, 8);
            if Vzdalenost[Smer1] < Vzdalenost[Smer2] then VedlejsiSmer:= SpojByty(Smer2, Smer1)
            else VedlejsiSmer:= SpojByty(Smer1, Smer2);
         end;

      Function KolmySmer(Smer: Byte): Word;  {Vyssi Byte je smer s vyssi prioritou}
         var Smer1, Smer2: Byte;
         begin
            Smer1:= Interval(Smer - 2, 1, 8);
            Smer2:= Interval(Smer + 2, 1, 8);
            if Vzdalenost[Smer1] < Vzdalenost[Smer2] then KolmySmer:= SpojByty(Smer2, Smer1)
            else KolmySmer:= SpojByty(Smer1, Smer2);
         end;

      begin
         Nejmensi:=1;
         for i:= 2 to 8 do
            if Vzdalenost[i] < Vzdalenost[Nejmensi] then Nejmensi:= i;

         PrioritaSmeru[1]:= Nejmensi;
            WPom:= VedlejsiSmer(PrioritaSmeru[1]);
         PrioritaSmeru[2]:= Hi(WPom);
         PrioritaSmeru[3]:= Lo(WPom);
            WPom:= KolmySmer(PrioritaSmeru[1]);
         PrioritaSmeru[4]:= Hi(WPom);
         PrioritaSmeru[5]:= Lo(WPom);
         PrioritaSmeru[8]:= MujOpacnySmer(PrioritaSmeru[1]);
            WPom:= VedlejsiSmer(PrioritaSmeru[8]);
         PrioritaSmeru[6]:= Hi(WPom);
         PrioritaSmeru[7]:= Lo(WPom);

         for i:= 1 to 8 do PoradiSmeru[PrioritaSmeru[i]]:= i;
      end;

   begin
      for i:= 1 to 8 do Vzdalenost[i]:=0;

      Pom:= Zacatek;
      repeat
         VyhodnotBranu(Pom^.X, Pom^.Y);
         Pom:= Pom^.Dalsi;
      until Pom = Zacatek;

      VyhodnotTabulku;
   end;

{****************************************************************************}
{KONTROLA CHYB}
{****************************************************************************}

Function KontrolaChyb(Hriste: PPole; Dx, Dy, X, Y: Integer; BVlastni, BSoupere: PBrana): Integer;
   var Chyba: Integer;

   Function JeSeznamOK(Zacatek: PBrana): Boolean;
      var Pom: PBrana;
          OK: Boolean;
      begin
         if Zacatek <> nil then begin
            OK:= True;
            Pom:= Zacatek;
            repeat
               if Pom^.Dalsi = nil then OK:= False;
               if Pom^.Predchozi = nil then OK:= False;
               Pom:= Pom^.Dalsi;
            until (Pom = Zacatek) or (not(OK));
         end else begin
            OK:= False;
         end;
         JeSeznamOK:= OK;
      end;

   begin
      {kontrola chyby nelze tahnout je v procedure VyhodnotSeznam}
      if (X<0) or (X>Dx) or (Y<0) or (Y>Dy) then Chyba:= -3
      else if (Dx<1) or (Dy<1) then Chyba:= -4
      else if Hriste = nil then Chyba:= -5
      else if BVlastni = nil then Chyba:= -6
      else if BSoupere = nil then Chyba:= -7
      else if not(JeSeznamOK(BVlastni)) then Chyba:= -8
      else if not(JeSeznamOK(BSoupere)) then Chyba:= -9
      else Chyba:= 0;
      KontrolaChyb:= Chyba;
   end;

{***************************************************************************}
{Deklarace FCE TAH}
{***************************************************************************}

Function R2Tah;
   var VyslednySmer: Byte;
       VyslX, VyslY, Chyba, VyslInteger: Integer;
       Hriste_1, Hriste_2: PPole;
       Seznam: PPozice;


   {************************************************************************}
   {Podprogram 1}
   {************************************************************************}

   Function ZvolDalsiMoznySmer(Zac: Byte; x, y: Integer): Byte;
   {Z tabulky priority smeru vybere mozny tah, protoze prioritni tah muze}
   {byt obsazenej kdyz nelze vybrat nic vraci 0}
      var i: Byte;
          Volny: Boolean;
      begin
         if Zac in [1..8] then i:= PoradiSmeru[Zac] else i:= 0;
         Repeat
            i:= i + 1;
            if i in [1..8] then Volny:= JeVolnySmer(CtiZeHriste(Hriste, Dx, Dy, x, y), PrioritaSmeru[i])
            else Volny:= False;
         Until (i>8) or (Volny);
         if i>8 then ZvolDalsiMoznySmer:= 0 else ZvolDalsiMoznySmer:= PrioritaSmeru[i];
      end;


   {************************************************************************}
   {Podprogram 2}
   {************************************************************************}

   Procedure OznacVsechnyKolem(Pole: PPole; x, y: Integer);
      var Ax, Ay: Integer;
          HodnotaXY,
          Cti, Zapis, Smer, Opak, HodnotaOznacenych, ZapisHodn,
          PocetVychozich, CtiZHriste_2, Souper, Vlastni: Byte;
          Hotovo, BranaVlastni, BranaSoupere: Boolean;

      Function VyberSmer(ZacSmer, AktualniHodnota: Byte): Byte;
         var Cti, Smer, Hodnota: Byte;
             Mensi: Boolean;
         begin
            Smer:= ZacSmer;
            repeat
               Smer:= ZvolDalsiMoznySmer(Smer, Ax, Ay);
               if Smer<>0 then begin
                  Cti:= CtiZeHriste(Pole, Dx, Dy, Ax+SmerXY[Smer, 1], Ay+SmerXY[Smer, 2]);
                  Hodnota:= Precti5Bitu(Cti);
                  if AktualniHodnota < Hodnota then Mensi:= true else Mensi:= false;
               end;
            until (Mensi) or (Smer=0);
            VyberSmer:= Smer;
         end;

      begin
         HodnotaXY:= 0;

         {zapsani vychoziho bodu XY do pole}
         Zapis:= Pripis3a5Bitu(PrioritaSmeru[1], HodnotaXY); {1. bod - tady me nezajima  smer-3 bity}
         ZapisDoHriste(Pole, Dx, Dy, x, y, Zapis);

         HodnotaOznacenych:= HodnotaXY + 1;
         Smer:= 0;
         Ax:= x;
         Ay:= y;
         Hotovo:= false;

         repeat
            Smer:= VyberSmer(Smer, HodnotaOznacenych);
            if Smer <> 0 then begin
               Opak:= MujOpacnySmer(Smer);
               Ax:= Ax + SmerXY[Smer, 1];
               Ay:= Ay + SmerXY[Smer, 2];
               Cti:= CtiZeHriste(Hriste, Dx, Dy, Ax, Ay);
               PocetVychozich:= PocetVychozichCest(Cti);
               if PocetVychozich <=1 then ZapisHodn:= HodnotaOznacenych+1
               else ZapisHodn:= HodnotaOznacenych;

               BranaSoupere:= JeToBrana(BSoupere, Ax, Ay);
               BranaVlastni:= JeToBrana(BVlastni, Ax, Ay);
               if BranaVlastni then ZapisHodn:= ZapisHodn + 2;
               if BranaSoupere then begin
                  ZapisHodn:= HodnotaXY;
                  Hotovo:= True;
               end;

               Zapis:= Pripis3a5Bitu(Smer, ZapisHodn);
               ZapisDoHriste(Pole, Dx, Dy, Ax, Ay, Zapis);

               if (PocetVychozich <= 1) or (PocetVychozich = 8) or (BranaSoupere) or (BranaVlastni) then begin
                  {BVlastni - pres ni nehledej, tzn. vrat se}
                  {BSoupere - ukonci vyhledavani}
                  CtiZHriste_2:= CtiZeHriste(Hriste_2, Dx, Dy, Ax, Ay);
                  Vlastni:= CtiZHriste_2 shr 7;
                  Souper:= CtiZHriste_2 and 127;
                  Pridej_SPozice(Seznam, Ax, Ay, ZapisHodn, Vlastni, Souper);

                  Ax:= Ax + SmerXY[Opak, 1];
                  Ay:= Ay + SmerXY[Opak, 2];
                  Smer:= Smer;
               end else begin
                  Smer:= 0;
               end;
            end else begin
               {navrat na predchozi policko}
               if (Ax = x) and (Ay = y) then begin
                  Hotovo:= true;
               end else begin
                  Cti:= CtiZeHriste(Pole, Dx, Dy, Ax, Ay);
                  Smer:= Precti3Bity(Cti);
                  Opak:= MujOpacnySmer(Smer);
                  Ax:= Ax + SmerXY[Opak, 1];
                  Ay:= Ay + SmerXY[Opak, 2];
               end;
            end;
         until Hotovo;
      end;


   {************************************************************************}
   {Podprogram 3}
   {************************************************************************}

   Procedure VyhodnotSeznam(Zacatek: PPozice; var KamX, KamY: Integer);
      var Pom: PPozice;
          Vzdal, Nejmensi: Real;
          Hodnoceni, KSouperi, KVlastni, Smer, PocetUzlu1, NejmPocetUzlu1: Byte;
          FirstTime: Boolean;

      Function VzdalenostOdBrany(Zacatek: PBrana; Ax, Ay: Integer): Real;
         var Vzdal: Real;
             Pom: PBrana;
         begin
            Vzdal:= 0;
            Pom:= Zacatek;
            repeat
               Vzdal:= Vzdal + VzdalenostAB(Pom^.X, Pom^.Y, Ax, Ay);
               Pom:= Pom^.Dalsi;
            until Pom = Zacatek;
            VzdalenostOdBrany:= Vzdal;
         end;

      Function PocetUzlu1Kolem(Ax, Ay: Integer): Byte;
         var i, Pocet, Cti, Cti2: Byte;
         begin
            Pocet:= 0;
            Cti:= CtiZeHriste(Hriste, Dx, Dy, Ax, Ay);
            for i:= 1 to 8 do begin
               if JeVolnySmer(Cti, i) then begin
                  Cti2:= CtiZeHriste(Hriste, Dx, Dy, Ax+SmerXY[i, 1], Ay+SmerXY[i, 2]);
                  if Cti2 <> 0 then begin {kdyz je to uzel}
                     Cti2:= CtiZeHriste(Hriste_2, Dx, Dy, Ax+SmerXY[i, 1], Ay+SmerXY[i, 2]);
                     Cti2:= Cti2 shr 7;
                     if Cti2 = 0 then Pocet:= Pocet + 1;
                  end;
               end;
            end;
            PocetUzlu1Kolem:= Pocet;
         end;

      Procedure NejmensiHodnoceni(Zacatek: PPozice; var Nejm, KSouperi, KVlastni: Byte);
      {najde v seznamu nejvyhodnejsi hodnotu, ktera byla pouzita pri hodnoceni policek}
         var Pom: PPozice;
         begin
            Pom:= Zacatek;
            while Pom<>nil do begin
               if (Pom^.Hodnota < Nejm) or (Pom = Zacatek) then begin
                  Nejm:= Pom^.Hodnota;
                  KSouperi:= Pom^.Souper;
                  KVlastni:= Pom^.Vlastni;
               end else begin
                  if Pom^.Hodnota = Nejm then
                     if Pom^.Vlastni > KVlastni then begin
                        KSouperi:= Pom^.Souper;
                        KVlastni:= Pom^.Vlastni;
                     end else begin
                        if Pom^.Vlastni = KVlastni then
                            if Pom^.Souper < KSouperi then KSouperi:= Pom^.Souper;
                     end;
               end;
               Pom:= Pom^.Dalsi;
            end;
         end;

      begin
         {nelze tahnout (bud vubec nebo je uz zavrenej a stejne skonci)}
         if Zacatek = nil then begin
            Smer:= ZvolDalsiMoznySmer(0, X, Y);
            if Smer <> 0 then begin
               KamX:= X + SmerXY[Smer, 1];
               KamY:= Y + SmerXY[Smer, 2];
            end else begin
               Chyba:= -10; {nelze dal tahnout}
            end;

         {lze tahnout a vybere nejlepsi}
         end else begin
            FirstTime:= True;
            NejmensiHodnoceni(Zacatek, Hodnoceni, KSouperi, KVlastni);
            Pom:= Zacatek;

            while Pom<>nil do begin
               if KVlastni <> 0 then begin {KVlastni=0 -> souper mi muze dat gol}
                  if (Pom^.Hodnota=Hodnoceni) and (Pom^.Souper=KSouperi) and (Pom^.Vlastni=KVlastni) then begin
                     Vzdal:= VzdalenostOdBrany(BSoupere, Pom^.x, Pom^.y) - VzdalenostOdBrany(BVlastni, Pom^.x, Pom^.y);
                     if (Vzdal < Nejmensi) or (FirstTime) then begin
                        if FirstTime then FirstTime:= False;
                        Nejmensi:= Vzdal;
                        KamX:= Pom^.x;
                        KamY:= Pom^.y;
                     end;
                  end;
               end else begin {KVlastni=0 -> souper mi muze dat gol}
                  if Pom^.Hodnota=Hodnoceni then begin
                     PocetUzlu1:= PocetUzlu1Kolem(Pom^.x, Pom^.y);
                     Vzdal:= VzdalenostOdBrany(BSoupere, Pom^.x, Pom^.y) - VzdalenostOdBrany(BVlastni, Pom^.x, Pom^.y);
                     if (FirstTime) or (PocetUzlu1<NejmPocetUzlu1) or
                        ((PocetUzlu1=NejmPocetUzlu1) and
                        ((Pom^.Souper<KSouperi) or (Pom^.Souper=KSouperi) and (Vzdal<Nejmensi))) then begin
                        if FirstTime then FirstTime:= False;
                        NejmPocetUzlu1:= PocetUzlu1;
                        Hodnoceni:= Pom^.Hodnota;
                        KSouperi:= Pom^.Souper;
                        Nejmensi:= Vzdal;
                        KamX:= Pom^.x;
                        KamY:= Pom^.y;
                     end;
                  end;
               end;
               Pom:= Pom^.Dalsi;
            end;  {while}
         end;
      end;


   {************************************************************************}
   {Podprogram 4}
   {************************************************************************}

   Procedure VytvorSeznamTahu(var Zacatek: PTah; OdkudX, OdkudY: Integer);
      var Cti, Opak: Byte;
      begin
         if Chyba <> -10 then begin
            repeat
               Cti:= CtiZeHriste(Hriste_1, Dx, Dy, OdkudX, OdkudY);
               Cti:= Precti3Bity(Cti);
               Opak:= MujOpacnySmer(Cti);

               OdkudX:= OdkudX + SmerXY[Opak, 1];
               OdkudY:= OdkudY + SmerXY[Opak, 2];

               PridejTahSeznam(Zacatek, Cti);
            until (X = OdkudX) and (Y = OdkudY);
         end;
      end;


   {************************************************************************}
   {Podprogram 5}
   {************************************************************************}

   Procedure OcislujHriste(Brana: PBrana; Pole: PPole);
      var SouradniceCti, SouradniceZapis: PSouradnice;
          SmerSeznam: PTah;
          Cislo, Cti, Smer, Opak, Hodnota, MaxOcislovani: Byte;
          Ax, Ay, Bx, By: Integer;
          Konec, Volno, MusiNacist: Boolean;

      Procedure PridejSouradnice(var Zacatek: PSouradnice; x, y: Integer);
         var Pom: PSouradnice;
         begin
            if MemAvail > SizeOf(Pom) then begin
               New(Pom);
               Pom^.Dalsi:= Zacatek;
               Pom^.x:= x;
               Pom^.y:= y;
               Zacatek:= Pom;
            end else begin
               PametOK:= False;
            end;
         end;

      Procedure PrectiAUvolniSouradnice(var Zacatek: PSouradnice; var x, y: Integer);
         var Pom: PSouradnice;
         begin
            if Zacatek<>nil then begin
               x:= Zacatek^.x;
               y:= Zacatek^.y;
               Pom:= Zacatek;
               Zacatek:= Zacatek^.Dalsi;
               Dispose(Pom);
            end;
         end;

      Procedure ZapisTo(x, y: Integer; Cislo: Byte);
         var Cti: Byte;
         begin
            Cti:= CtiZeHriste(Pole, Dx, Dy, x, y);
            if Brana = BVlastni then begin
               Cislo:= Cislo shl 7;       {1. bit je to, co chci}
               Cti:= Cti and 127;         {1. bit je 0}
               Cislo:= Cti or Cislo;
            end else begin
               Cislo:= Cislo or 128;      {1. bit na 1}
               Cti:= Cti or 127;          {7 bitu na 1}
               Cislo:= Cti and Cislo;
            end;
            ZapisDoHriste(Pole, Dx, Dy, x, y, Cislo);
         end;

      Function PrectiTo(x, y: Integer): Byte;
         var Cti: Byte;
         begin
            Cti:= CtiZeHriste(Pole, Dx, Dy, x, y);
            if Brana = BVlastni then Cti:= Cti shr 7
            else Cti:= Cti and 127;
            PrectiTo:= Cti;
         end;

      Procedure NactiSouradniceBrany(BranaZac: PBrana; var Seznam: PSouradnice);
      {zapise do pole hodnoty 0 na souradnice brany}
         var Pom: PBrana;
         begin
            Pom:= BranaZac;
            repeat
               PridejSouradnice(Seznam, Pom^.x, Pom^.y);
               ZapisTo(Pom^.x, Pom^.y, 0);
               Pom:= Pom^.Dalsi;
            until Pom = BranaZac;
         end;

      begin {OcislujHriste}
         if Brana = BVlastni then MaxOcislovani:= 1
         else MaxOcislovani:= 127;

         SouradniceCti:= nil;
         SouradniceZapis:= nil;
         SmerSeznam:= nil;
         Cislo:= 0;
         NactiSouradniceBrany(Brana, SouradniceCti);

         while (SouradniceCti<>nil) and (Cislo<MaxOcislovani) do begin
            while SouradniceCti<>nil do begin
               Konec:= False;
               PrectiAUvolniSouradnice(SouradniceCti, Ax, Ay); {tento bod uz je ocislovanej}
               Smer:= 1;
               MusiNacist:= True;

               {********* OCISLOVANI ***************************************}
               repeat
                  if MusiNacist then begin
                     {jsem na novem bodu - tzn. musim precist uzel}
                     Cti:= CtiZeHriste(Hriste, Dx, Dy, Ax, Ay);
                     Volno:= JeVolnySmer(Cti, Smer);
                     if Volno then begin
                        Bx:= Ax+SmerXY[Smer, 1];
                        By:= Ay+SmerXY[Smer, 2];
                        Hodnota:= PrectiTo(Bx, By);
                     end;
                  end else begin
                      {jsem na stejnem bodu - zpusobi potom, ze se posune na dalsi smer}
                      Musinacist:= True;
                      Volno:= False;
                  end;

                  if (Volno) and (Hodnota>Cislo) then begin
                     Cti:= CtiZeHriste(Hriste, Dx, Dy, Bx, By);
                     if PocetVychozichCest(Cti)=8 then begin
                        {zapsani vedlejsiho samostatneho bodu a uloz. souradnic}
                        ZapisTo(Bx, By, Cislo);
                        PridejSouradnice(SouradniceZapis, Bx, By);
                        MusiNacist:= False;
                     end else begin
                        {prepnuti na dalsi bod (uzel)}
                        PridejTahSeznam(SmerSeznam, Smer);
                        Ax:= Bx;
                        Ay:= By;
                        ZapisTo(Ax, Ay, Cislo);
                        Smer:= 1;
                     end;
                  end else begin {dalsi smer}
                     Smer:= Smer + 1;
                     repeat
                        if Smer>8 then begin
                           if SmerSeznam<>nil then begin
                              Smer:= PrectiAUvolniMujTah(SmerSeznam);
                              Opak:= MujOpacnySmer(Smer);
                              Ax:= Ax + SmerXY[Opak, 1];
                              Ay:= Ay + SmerXY[Opak, 2];
                              Smer:= Smer + 1;
                           end else begin
                              Konec:= True;
                           end;
                        end;
                     until (Konec) or (Smer<=8);
                  end;
               until Konec;
               {************************************************************}

            end; {while 2}
            SouradniceCti:= SouradniceZapis;
            SouradniceZapis:= nil;
            Cislo:= Cislo + 1;
         end; {while 1}

         {kdyz uz je cislo = MaxOcislovani}
         while SouradniceCti<>nil do PrectiAUvolniSouradnice(SouradniceCti, Ax, Ay);
      end;


{***************************************************************************}
{ZACATEK FCE TAH}
{***************************************************************************}

   begin
      Chyba:= KontrolaChyb(Hriste, Dx, Dy, X, Y, BVlastni, BSoupere);

      if Poprve then begin
         Poprve:= False;
         PametOK:= True;
         Seznam:= nil;
         SeznamTahu:=nil;

         TabulkaPrioritySmeru(BSoupere, X, Y); {hierarchie nejlepsich smeru}

         if MemAvail > 2*Dx*Dy then begin
            Hriste_1:= AlokujHriste(Dx*Dy);       {na oznaceni kolem X,Y}
            VyplnPamet(Hriste_1, 31, Dx*Dy);

            {ocisluje do pole vzdalenosti od bran, levy bit je na vzdal od vlastni brany a zbytek na souperovu}
            Hriste_2:= AlokujHriste(Dx*Dy);       {na ocislovani od brany}
            VyplnPamet(Hriste_2, 255, Dx*Dy);
            OcislujHriste(BVlastni, Hriste_2);
            OcislujHriste(BSoupere, Hriste_2);

            {oznaci smery od bodu XY k vyslednym bodum a vytvori seznam vysl. bodu}
            {do seznamu zapise i vzdalenosti od bran}
            {kdyz neni zadna moznost kam jit tak je nil}
            OznacVsechnyKolem(Hriste_1, X, Y);
            VyhodnotSeznam(Seznam, VyslX, VyslY); {vybere ze seznamu nejlepsi souradnice,}
                                                  {kdyz je seznam=nil (uz urcite prohraje) ->}
                                                  { zkousi zvolit smer jinak Chyba=-10}
            UvolniHriste(Hriste_2, Dx*Dy);
            Uvolni_SPozice(Seznam);               {souradnice bodu uz zna VyslX, VyslY}

            VytvorSeznamTahu(SeznamTahu, VyslX, VyslY); {od VyslX, VyslY}
            UvolniHriste(Hriste_1, Dx*Dy);
         end else begin
            PametOK:= False;
         end;
      end;

      if Not(PametOK) then Chyba:= -1;

      if Chyba = 0 then begin
         VyslednySmer:= PrectiAUvolniMujTah(SeznamTahu);
         VyslednySmer:= PrevedMujSmer(VyslednySmer);
         VyslInteger:= VyslednySmer;     {SpojByty(VyslednySmer, 0);}
      end else begin
         VyslInteger:= Chyba;
      end;

      R2Tah:= VyslInteger;
      if SeznamTahu = nil then Poprve:= True;
   end;
{***************************************************************************}
{KONEC FCE TAH}
{***************************************************************************}

{init}
Begin
   Poprve:= True;
End.